/************************************************************************/
/*									*/
/* եå (OS¸)						*/
/*									*/
/*									*/
/* ڴؿ								*/
/*									*/
/* int  graphic_system_init( void )					*/
/* void graphic_system_term( void )					*/
/* void graphic_system_restart( int redraw_flag )			*/
/* void put_image( void )						*/
/* void trans_palette( SYSTEM_PALETTE_T syspal[] )			*/
/* void set_mouse_visible( void )					*/
/* void set_mouse_invisible( void )					*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <unistd.h>

#include "quasi88.h"
#include "initval.h"
#include "graph.h"
#include "screen.h"

#include "device.h"


#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>

static	XShmSegmentInfo	SHMInfo;
#endif

#ifdef	USE_DGA
#include <unistd.h>
#include <sys/types.h>
#include <X11/extensions/xf86dga.h>
#endif



int	colormap_type   = 0;		/* 顼ޥåפΥ	-1/0/1/2 */
#ifdef MITSHM
int	use_SHM		= TRUE;		/* MIT-SHM Ѥ뤫ɤ	*/
#endif
int	hide_mouse	= FALSE;	/* ޥɽ뤫ɤ	*/
int	grab_mouse	= FALSE;	/* ֤뤫ɤ		*/

int	WIDTH  = 0;			/* ̥Хåե		*/
int	HEIGHT = 0;			/* ̥Хåեĥ		*/
int	DEPTH  = 8;			/* ӥåȿ	(8 or 16 or 32)	*/
int	SCREEN_W = 0;			/* 襨ꥢ		*/
int	SCREEN_H = 0;			/* 襨ꥢĥ		*/
int	SCREEN_DX = 0;
int	SCREEN_DY = 0;
int	VIEWPORT_W = 0;			/* ɽꥢ		*/
int	VIEWPORT_H = 0;			/* ɽꥢĥ		*/
int	VIEWPORT_DX = 0;
int	VIEWPORT_DY = 0;
int	SCREEN_OFFSET;

static	int     SIZE_OF_DEPTH;		/* Хȿ	(1 or 2 or 4)	*/

int	screen_size = SCREEN_SIZE_FULL;	/* ̥ 0:Ⱦʬ/1:ɸ/2:*/
int	screen_size_max = SCREEN_SIZE_DOUBLE;

char	*screen_buf;			/* ɽѥХåե	 	*/
					/* 640x400 or 320x200 or1280x800*/
					/* 8(char)or16(short)or32(long)	*/

char	*screen_start;			/* ɽХåե賫ϰ	*/


	Ulong	color_pixel[16];	/* 16ѥåʬpixel	*/
	Ulong	color_half_pixel[16][16];	/* halfѤ
					 ե륿󥰤ѥå	*/

					/* colormap_type==2 Υ	*/
static	Ulong	color_buf[16  +15+14+13+12+11+10+9+8+7+6+5+4+3+2+1];
static	int	color_count;	/* +15..+1120ʬ,ե륿Ѥο */

static	int	color_h_pixel_exist = FALSE;	/*ե륿ѿݲ */
static	Ulong	color_h_pixel[15+14+13+12+11+10+9+8+7+6+5+4+3+2+1];


	Display	 *display;
	Window	 window;
	Atom	 atom_sigint;
	Atom	 atom_WM_close_type;
	Atom	 atom_WM_close_data;
static	Colormap colormap;
static	XImage   *image;
static	GC       gc;
	Ulong    white, black;


static const struct{
  int w, h;
} screen_size_tbl[ END_of_SCREEN_SIZE ] = {
  {  320,  200, },	/* SCREEN_SIZE_HALF	*/
  {  640,  400, },	/* SCREEN_SIZE_FULL	*/
  { 1280,  800, },	/* SCREEN_SIZE_DOUBLE	*/
};


#ifdef	USE_DGA
int	use_DGA		= FALSE;	/* XF86-DGA Ѥ뤫ɤ	*/
int	enable_DGA	= FALSE;	/* XF86-DGA Ѥɤ	*/
int	restart_DGA	= FALSE;	/* XF86-DGA Ǻƽ	*/
static	char	*dga_addr;
static	int	dga_width;
static	int	dga_bank;
static	int	dga_ram;
#endif


/******************************************************************************

                                 WIDTH
	 

	+----------------------------------------------------+
	| VIEWPORT_DY    SCREEN_DY                       |  
	|                                                |  
	|            +------------------------+            |  
	|||            |  
	|VIEWPORT_DX |         VIEWPORT_W     |            |  
	|            |   +------------------+   |            |  
	|||   |            |  
	|    SCREEN_DX   |     SCREEN_W   |   |            |   HEIGHT
	|            |   |                |   |            |  
	|            |   |  SCREEN_H      |   |            |  
	|            |   |                |   |            |  
	|            |   |                |   |            |  
	|            |   +------------------+   |            |  
	|            |                          | 
       Ĩ+--------------------------+            |  
       SCREEN_OFFSET                                         |  
	|                                                    |  
	+----------------------------------------------------+

	WIDTH		ݤեåХåեβ
	HEIGHT		                            ĥ

	SCREEN_W	襨ꥢΥ  (320/640/1280Τ줫)
	SCREEN_H	                  (200/400/ 800Τ줫)
	SCREEN_DX	Хåեκü襨ꥢκüޤǤεΥ
	SCREEN_DY	        ü          üޤǤεΥ

	VIEWPORT_W	ɽꥢΥ 
	VIEWPORT_H	                 
	VIEWPORT_DX	ХåեκüɽꥢκüޤǤεΥ
	VIEWPORT_DY	        ü          üޤǤεΥ

	(̾ϡSCREEN_*  VIEWPORT_* ϰ)


	SCREEN_OFFSET	襨ꥢαü顢κüޤǤεΥ
				= WIDTH - SCREEN_W;
	DEPTH		depth (8/16/32)
	SIZE_OF_DEPTH	log2(DEPTH)/8  = 1/2/4

******************************************************************************/



#ifdef MITSHM
/* MIT-SHM μԤȥå */
static	int	private_handler( Display *display, XErrorEvent *E )
{
  char	str[256];

  if( E->error_code == BadAccess ){
    /*fprintf( stderr, "X Error BadAccrss\n");*/
    use_SHM = FALSE;
    return 0;
  }

  XGetErrorText( display, E->error_code, str, 256 );
  fprintf( stderr, "X Error (%s)\n", str );
  fprintf( stderr, " Error Code   %d\n", E->error_code );
  fprintf( stderr, " Request Code %d\n", E->request_code );
  fprintf( stderr, " Minor code   %d\n", E->minor_code );
  main_exit(1);
  return 1;
}
#endif


static	void	alloc_pixmap_for_invisible_mouse( void );
static	void	free_pixmap_for_invisible_mouse( void );


/*
 * ̥ڤؤΤȤö graphic_system_term ƤǤ顢
 *  graphic_system_init ƤӽФƤ롣
 *	ǡDGAξ 
 *	ǽνroot¤ΤǡƽǤʤ
 *	٥ǥץ쥤ĤƤޤȡɬפ
 *	Ȥ꤬Τǡ
 *	graphic_system_initǤΤߡDGA
 *	ؤξ graphic_system_term ǥǥץ쥤Ĥʤ
 *	褦ˤʤȤʤ
 *	ʲϤؼ뤿Υե饰ޤޤˤʤäƤ
 */
static	int	graphic_system_initialize_done = FALSE;
static	int	graphic_system_need_restart    = FALSE;

/************************************************************************/
/* եåƥ (X11) ν					*/
/************************************************************************/
int	graphic_system_init( void )
{
  Screen  *screen;
  XEvent  event;
  Visual  *visual;
  Ulong   plane[1];	/* dummy */
  int     i, j;



  if( verbose_proc ) printf("Initializing Graphic System (X11)\n");


	/* ǥץ쥤򳫤 */

  if( graphic_system_initialize_done==FALSE ){
    int err = TRUE;

    if( verbose_proc ) printf("  Opening display...");
    display = XOpenDisplay( NULL );
    if( !display ){ if( verbose_proc ) printf("FAILED\n"); return(0); }
    else          { if( verbose_proc ) printf("OK\n");                }

#ifdef	USE_DGA
    if( use_DGA ){
      char *s;
		/* DGA  ġ root¤ɬסġ */

      if( verbose_proc ) printf("  Checking DGA...");
      if( geteuid() ){
	if( verbose_proc ) printf("FAILED ... Must be suid root\n");
	goto GRAPH_INIT_RESULT;
      }
      if( !(s = getenv("DISPLAY")) || (s[0] != ':') ){
	if( verbose_proc )printf("FAILED ... Only works on a local display\n");
	goto GRAPH_INIT_RESULT;
      }
      if( !XF86DGAQueryVersion( display, &i, &i ) ){
	if( verbose_proc )printf("FAILED ... (XF86DGAQueryVersion)");
	goto GRAPH_INIT_RESULT;
      }
      if( !XF86DGAQueryExtension( display, &i, &i) ){
	if( verbose_proc )printf("FAILED ... (XF86DGAQueryExtension)");
	goto GRAPH_INIT_RESULT;
      }
      if( !XF86DGAQueryDirectVideo( display, DefaultScreen(display), &i ) ){
	if( verbose_proc )printf("FAILED ... (XF86DGAQueryDirectVideo)");
	goto GRAPH_INIT_RESULT;
      }
      if( !(i & XF86DGADirectPresent) ){
	if( verbose_proc )printf("FAILED ... Xserver not support DirectVideo");
	goto GRAPH_INIT_RESULT;
      }
      if( !XF86DGAGetVideo( display, DefaultScreen(display), 
			    &dga_addr, &dga_width, &dga_bank, &dga_ram) ){
	if( verbose_proc )printf("FAILED ... (XF86DGAGetVideo)");
	goto GRAPH_INIT_RESULT;
      }
    }
      /* Display  Open  DGA ν root ¤ */
#endif

    if( setuid( getuid() ) ){	/* ץΥ桼IDᤷƤ */
      goto GRAPH_INIT_RESULT;
    }
    err = FALSE;

  GRAPH_INIT_RESULT:
    if( err ){
      XCloseDisplay( display );
      return 0;
    }

    graphic_system_initialize_done = TRUE;
  }

  screen   = DefaultScreenOfDisplay( display );
  white    = WhitePixelOfScreen( screen );
  black    = BlackPixelOfScreen( screen );
  gc       = DefaultGCOfScreen( screen );
  colormap = DefaultColormapOfScreen( screen );
  visual   = DefaultVisualOfScreen( screen );


	/* ɥ򥻥å		*/
	/* WIDTH/HEIGHT ϥޥɥ饤Ǽ	*/

  SCREEN_W = screen_size_tbl[screen_size].w;
  SCREEN_H = screen_size_tbl[screen_size].h;
  if( WIDTH  < SCREEN_W ) WIDTH  = SCREEN_W;
  if( HEIGHT < SCREEN_H ) HEIGHT = SCREEN_H;
  SCREEN_OFFSET = WIDTH - SCREEN_W;

  SCREEN_DX = ( ( WIDTH - SCREEN_W ) / 2 ) & ~7;	/* 8ܿ */
  SCREEN_DY = ( ( HEIGHT- SCREEN_H ) / 2 ) & ~1;	/* 2ܿ */

  VIEWPORT_W  = WIDTH;
  VIEWPORT_H  = HEIGHT;
  VIEWPORT_DX = 0;
  VIEWPORT_DY = 0;

  DEPTH = DefaultDepthOfScreen( screen );
  if( DEPTH<4 ){
    if( verbose_proc ) printf("This Display don't support over 4 bit color\n");
    return (0);
  }
  if     ( DEPTH<= 8 ) SIZE_OF_DEPTH = 1;
  else if( DEPTH<=16 ) SIZE_OF_DEPTH = 2;
  else                 SIZE_OF_DEPTH = 4;



	/* DGA  ʲǽѤʤС*/

#ifdef	USE_DGA
  if( use_DGA ){
    int i;

	/* ХåեΥ */

			/* Х󥯤2İʾ夢νΤʤΤǡ */
    if( dga_ram * 1024 / dga_bank > 1 ){
      if( verbose_proc ) printf("FAILED ... (sorry... bank>1 ...  ;_;)");
      return(0);
    }
    WIDTH  = dga_width;
    HEIGHT = dga_bank/dga_width/SIZE_OF_DEPTH;


	/* ӥ塼ݡȤΥ */

    if( !XF86DGAGetViewPortSize( display, DefaultScreen(display), 
				 &VIEWPORT_W, &VIEWPORT_H ) ){
      VIEWPORT_W  = WIDTH;
      VIEWPORT_H  = HEIGHT;
    }
    VIEWPORT_DX = ( WIDTH  - VIEWPORT_W ) / 2;
    VIEWPORT_DY = ( HEIGHT - VIEWPORT_H ) / 2;



	/* ӥ塼ݡȥ顢ɽǽʥå롣*/
	/* ɽǽʥ̵ (320x200̤) ʤ顢顼     */

    for( i=0; i<END_of_SCREEN_SIZE; i++ ){
      if( VIEWPORT_W < screen_size_tbl[i].w ||
	  VIEWPORT_H < screen_size_tbl[i].h ){
	break;
      }
    }
    if( i == 0 ){
      if( verbose_proc ) printf("FAILED ... (sorry... bad resolution .. X_X)");
      return(0);
    }else{
      screen_size_max = i - 1;
    }


	/* Υ׻ */

    if( screen_size > screen_size_max ){
      screen_size = screen_size_max;
    }
    SCREEN_W = screen_size_tbl[screen_size].w;
    SCREEN_H = screen_size_tbl[screen_size].h;

    SCREEN_OFFSET = WIDTH - SCREEN_W;

    SCREEN_DX = ( ( WIDTH - SCREEN_W ) / 2 ) & ~7;	/* 8ܿ */
    SCREEN_DY = ( ( HEIGHT- SCREEN_H ) / 2 ) & ~1;	/* 2ܿ */
    if( verbose_proc ) printf("OK");


	/* DGA ͭˤܡɡޥ򥰥֤ */

    window = DefaultRootWindow(display);

    XF86DGADirectVideo( display, DefaultScreen(display), 
			XF86DGADirectGraphics|
			XF86DGADirectMouse|
			XF86DGADirectKeyb);

    XGrabKeyboard( display, window, True, GrabModeAsync,
		   GrabModeAsync,  CurrentTime);

    XGrabPointer( display, window, True,
		  PointerMotionMask | ButtonPressMask | ButtonReleaseMask,
		  GrabModeAsync, GrabModeAsync, None,  None, CurrentTime);


	/* 顼ޥåפݤ */

    switch( colormap_type ){
    case -1:
    case 0:
      colormap_type = 1;	/* FALLTHROUGH */
    case 1:
      if( verbose_proc ) printf("  Allocating colormap...");
      if( visual->class == PseudoColor ||
	  visual->class == DirectColor ){
	colormap = XCreateColormap( display, window, visual, AllocAll );
	for( i=0; i<16; i++ ) 		/* 顼 015֤ޤǤ */
	  color_pixel[ i ] = i;		/* 16Ѥ롣         */
	if( verbose_proc ) printf("...OK\n");

	/* ץ饤١ȥ顼ޥåפʤΤǼϤǹ (black) ݤ */

	if( DEPTH == 4 ){		/* ʾ奫顼뤬ʤΤ */
	  black = 8;			/*  8 (ƥȤι)  */
	}else{
	  XColor  color;		/* ޤ顼뤬Τǡ */
	  color.pixel = black = 16;	/*  16 ˳Ƥ   */
	  color.blue  = color.green = color.red = 0;
	  color.flags = DoRed|DoGreen|DoBlue;
	  XStoreColor( display, colormap, &color );
				/* 8bpp (256) ʾ夢СHALF */
				/* ե륿 Υ顼ݲǽ */
	  if( verbose_proc ) printf("    Allocating interpolation color...");
	  if( DEPTH >= 8 ){
	    int x = 17;	
	    for( i=0; i<16; i++ ){
	      color_half_pixel[i][i] = color_pixel[i];
	    }
	    for( i=0; i<16; i++ ){
	      for( j=i+1; j<16; j++ ){
		color_half_pixel[i][j] = x ++;
		color_half_pixel[j][i] = color_half_pixel[i][j];
	      }
	    }
	    color_h_pixel_exist=TRUE;
	    if( verbose_proc ) printf("OK\n");
	  }else{
	    color_h_pixel_exist = FALSE;
	    if( verbose_proc ) printf("FAILED (can't use -interp)\n");
	  }
	}
	break;
      }
      if( verbose_proc ) printf("FAILED...Not Allocate colormap\n");
      colormap_type = 2;	/* FALLTHROUGH */
    case 2:
      color_count = 0;
      color_h_pixel_exist=TRUE;
      break;
    }


	/* ꡼ХåեΡ賫ϰ֤	*/

    screen_buf = dga_addr;
    screen_start = &screen_buf[ (WIDTH*SCREEN_DY +SCREEN_DX) *SIZE_OF_DEPTH ];


	/* X Υޥɽɽ */

    alloc_pixmap_for_invisible_mouse();

	/* ȥԡ OFF */

    XAutoRepeatOff( display );


	/* ٥ȤꤹܤΤǡꤷʤ */
#if 0
    XSelectInput( display, window,
		  FocusChangeMask|ExposureMask|KeyPressMask|KeyReleaseMask|
		  ButtonPressMask|ButtonReleaseMask|PointerMotionMask );
#endif


	/* DGA  */


    XF86DGASetViewPort( display, DefaultScreen(display), 
			VIEWPORT_DX, VIEWPORT_DY );

    XF86DGASetVidPage( display, DefaultScreen(display), 0 );


	/* ̤١ꥢ */
    screen_buf_init();


    grab_mouse = FALSE;
    enable_DGA = TRUE;
    restart_DGA	= TRUE;


    return(1);
  }

#endif

	/* ɥ򳫤 */

  if( verbose_proc ) printf("  Opening window...");
  window = XCreateSimpleWindow( display, RootWindowOfScreen(screen), 0, 0,
			        WIDTH, HEIGHT, 0, white, black );
  if( !window ){ if( verbose_proc ) printf("FAILED\n"); return(0); }
  else         { if( verbose_proc ) printf("OK\n");                }



	/* ɥޥ͡㡼ؼ */

  {
    XSizeHints Hints;
    XWMHints WMHints;

    Hints.flags      = PSize|PMinSize|PMaxSize;
    Hints.min_width  = Hints.max_width  = Hints.base_width  = WIDTH;
    Hints.min_height = Hints.max_height = Hints.base_height = HEIGHT;
    WMHints.input = True;
    WMHints.flags = InputHint;

    XSetWMHints( display, window, &WMHints );
    XSetWMNormalHints( display, window, &Hints );
    XStoreName( display, window, Q_TITLE " ver " Q_VERSION );
  }


	/* 顼ݤ					*/
	/* colormap_type == -1 (ͭ顼뤫16ĳ)	*/
	/*		     0 (ͭ顼뤫16+ ĳ)	*/
	/*		     1 (ץ쥤١ȥ顼ޥåפ)	*/
	/*		     2 (顼ݤʤ)		*/

  switch( colormap_type ){
  case -1:
  case 0:
    if( verbose_proc ) printf("  Allocating color-cells...(Shared...)");
    if( XAllocColorCells( display, colormap, True, plane, 0, color_pixel, 16)){
      if( verbose_proc ) printf("...OK [Default Colormap]\n");

      if( colormap_type==-1 ){		/* -1 λϡHALFե륿 */
	color_h_pixel_exist = FALSE;	/* ѤΥ顼ݤʤ  */
	break;
      }

      if( verbose_proc ) printf("    Allocating interpolation color-cells...");
      if( XAllocColorCells( display, colormap, True, plane, 0, color_h_pixel, 
			    			countof(color_h_pixel) )){
	int x = 0;		/* HALFե륿ѤΥ顼뤬  */
	for( i=0; i<16; i++ ){	/* Ǥ顢color_half_pixel Ÿ */
	  color_half_pixel[i][i] = color_pixel[i];
	}
	for( i=0; i<16; i++ ){
	  for( j=i+1; j<16; j++ ){
	    color_half_pixel[i][j] = color_h_pixel[ x ++ ];
	    color_half_pixel[j][i] = color_half_pixel[i][j];
	  }
	}
	color_h_pixel_exist=TRUE;
	if( verbose_proc ) printf("OK\n");
      }else{
	color_h_pixel_exist = FALSE;
	if( verbose_proc ) printf("FAILED (can't use -interp)\n");
      }
      break;
    }
    if( verbose_proc ) printf("FAILED...Try Again..\n");
    colormap_type = 1;	/* FALLTHROUGH */
  case 1:
    if( verbose_proc ) printf("  Allocating color-cells...(Private...)");
    if( visual->class == PseudoColor ||
        visual->class == DirectColor ){
      colormap = XCreateColormap( display, window, visual, AllocAll );
      XSetWindowColormap( display, window, colormap );
      for( i=0; i<16; i++ ) 		/* 顼 015֤ޤǤ */
	color_pixel[ i ] = i;		/* 16Ѥ롣         */
      if( verbose_proc ) printf("...OK [New Colormap]\n");

	/* ץ饤١ȥ顼ޥåפʤΤǼϤǹ (black) ݤ */

      if( DEPTH == 4 ){			/* ʾ奫顼뤬ʤΤ */
	black = 8;			/*  8 (ƥȤι)  */
      }else{
	XColor  color;			/* ޤ顼뤬Τǡ */
	color.pixel = black = 16;	/*  16 ˳Ƥ   */
	color.blue  = color.green = color.red = 0;
	color.flags = DoRed|DoGreen|DoBlue;
	XStoreColor( display, colormap, &color );
				/* 8bpp (256) ʾ夢СHALF */
				/* ե륿 Υ顼ݲǽ */
	if(verbose_proc) printf("    Allocating interpolation color-cells...");
	if( DEPTH >= 8 ){
	  int x = 17;	
	  for( i=0; i<16; i++ ){
	    color_half_pixel[i][i] = color_pixel[i];
	  }
	  for( i=0; i<16; i++ ){
	    for( j=i+1; j<16; j++ ){
	      color_half_pixel[i][j] = x ++;
	      color_half_pixel[j][i] = color_half_pixel[i][j];
	    }
	  }
	  color_h_pixel_exist=TRUE;
	  if( verbose_proc ) printf("OK\n");
	}else{
	  color_h_pixel_exist = FALSE;
	  if( verbose_proc ) printf("FAILED (can't use -interp)\n");
	}
      }
      break;
    }
    if( verbose_proc ) printf("FAILED...Not Alloc color-cells\n");
    colormap_type = 2;	/* FALLTHROUGH */
  case 2:
    color_count = 0;
    color_h_pixel_exist=TRUE;
    break;
  }
    

	/* ꡼Хåեγ */

#ifdef MITSHM

  if( use_SHM ){			/* MIS-SHM Ƥ뤫Ƚ */
    int	tmp;
    if( ! XQueryExtension( display, "MIT-SHM", &tmp, &tmp, &tmp ) ){
      if( verbose_proc ) printf("X-Server not support MIT-SHM\n");
      use_SHM = FALSE;
    }
  }

  if( use_SHM ){

    if( verbose_proc ) printf("  Using shared memory:\n    Creating image...");
    image = XShmCreateImage( display, visual, DEPTH,
			     ZPixmap, NULL, &SHMInfo, WIDTH, HEIGHT );

    if( image ){

      if( verbose_proc ) printf("OK\n    Getting SHM info...");
      SHMInfo.shmid = shmget( IPC_PRIVATE,
			      image->bytes_per_line * image->height,
			      IPC_CREAT|0777 );
      if( SHMInfo.shmid<0 ){
	use_SHM = FALSE;
      }

      XSetErrorHandler( private_handler );	/* 顼ϥɥ򲣼 */
						/* (XShmAttach()۾︡) */
      if( use_SHM ){

	if( verbose_proc ) printf("OK\n    Allocating SHM...");
	screen_buf = 
	  image->data = SHMInfo.shmaddr = (char *)shmat( SHMInfo.shmid, 0, 0 );
	if( !screen_buf ){
	  use_SHM = FALSE;
	}


	if( use_SHM ){
	  if( verbose_proc ) printf("OK\n    Attaching SHM...");
	  SHMInfo.readOnly = False;
	  if( !XShmAttach( display, &SHMInfo ) ){
	    use_SHM = FALSE;
	  }

	  XSync( display, False );
	  /*
	     sleep(2);
	  */
	}
      }

      if( SHMInfo.shmid>=0 ) shmctl( SHMInfo.shmid, IPC_RMID, 0 );


      if( use_SHM ){				/* ٤ */
	if( verbose_proc ) printf("OK\n");
      }else{					/* ɤäǼ */
	if( verbose_proc ) printf("FAILED ... Not using shared memory\n");
	if( SHMInfo.shmaddr ) shmdt( SHMInfo.shmaddr );
	XDestroyImage( image );
	image = NULL;
      }

      XSetErrorHandler( None );			/* 顼ϥɥ᤹ */

    }else{
      if( verbose_proc ) printf("FAILED\n");
      use_SHM = FALSE;
    }
  }

  if( !use_SHM )
#endif
  {
	/* ꡼Хåե */

    if( verbose_proc ) printf("  Allocating screen buffer...");
    screen_buf = (char *)malloc( SIZE_OF_DEPTH *HEIGHT*WIDTH );
    if( !screen_buf ){ if( verbose_proc ) printf("FAILED\n"); return(0); }
    else             { if( verbose_proc ) printf("OK\n");                }

	/* ꡼Хåե򥤥᡼˳ */

    if( verbose_proc ) printf("Creating image...");
    image = XCreateImage( display, visual, DEPTH,
			  ZPixmap, 0, screen_buf, WIDTH, HEIGHT, 8, 0);
    if( !image ){ if( verbose_proc ) printf("FAILED\n"); return(0); }
    else        { if( verbose_proc ) printf("OK\n");                }
  }

	/* ꡼ХåեΡ賫ϰ֤	*/

  screen_start = &screen_buf[ (WIDTH*SCREEN_DY + SCREEN_DX) * SIZE_OF_DEPTH ];



	/* ̤١ꥢ */
  screen_buf_init();


	/* X Υޥɽɽ */

  alloc_pixmap_for_invisible_mouse();

  if( hide_mouse ) set_mouse_invisible();
  else		   set_mouse_visible();


	/* ȥԡ OFF */

  XAutoRepeatOff( display );


	/* ٥Ȥ */

  XSelectInput( display, window,
	        FocusChangeMask|ExposureMask|KeyPressMask|KeyReleaseMask|
	        ButtonPressMask|ButtonReleaseMask|PointerMotionMask );


	/* λǤơȥ */

  atom_WM_close_type = XInternAtom( display, "WM_PROTOCOLS", False );
  atom_WM_close_data = XInternAtom( display, "WM_DELETE_WINDOW", False );
  XSetWMProtocols( display, window, &atom_WM_close_data, 1 );

  atom_sigint = XInternAtom( display, "QUASI88_SIGINT", False );


	/* ɥɽ */

  XMapRaised( display, window );
  XClearWindow( display, window );
  XWindowEvent( display, window, ExposureMask, &event );


	/* ֤	*/

  if( grab_mouse ){
    XGrabPointer( display, window, True, 0, GrabModeAsync, GrabModeAsync, 
		  window, None, CurrentTime );
  }


  return(1);
}

/************************************************************************/
/* եåƥ (X11) νλ					*/
/************************************************************************/
void	graphic_system_term( void )
{
  XFlush( display );

  free_pixmap_for_invisible_mouse();

  switch( colormap_type ){
  case -1:
  case 0:
    XFreeColors( display, colormap, color_pixel, 16, 0 );	
    if( color_h_pixel_exist )
      XFreeColors( display, colormap, color_h_pixel, countof(color_h_pixel),0);
    break;

  case 1:	
    XFreeColormap( display, colormap );			
    break;

  case 2:
    if( color_count )
      XFreeColors( display, colormap, color_buf, color_count, 0 );
    break;
  }


#ifdef	USE_DGA
  if( use_DGA ){
    XF86DGADirectVideo( display, DefaultScreen(display), 0 );

    XUngrabPointer(  display, CurrentTime);
    XUngrabKeyboard( display, CurrentTime);

  }else
#endif

  {
#ifdef MITSHM
    if( use_SHM ){
      XShmDetach( display, &SHMInfo );
      if( SHMInfo.shmaddr ) shmdt( SHMInfo.shmaddr );
      /*if( SHMInfo.shmid>=0 )shmctl( SHMInfo.shmid,IPC_RMID,0 );*/
    }
#endif
    XDestroyImage( image );
    XDestroyWindow( display, window );


    if( grab_mouse ){
      XUngrabPointer( display, CurrentTime );
    }
  }

  XAutoRepeatOn( display );

  if( graphic_system_need_restart==FALSE ){
    XCloseDisplay( display );
  }else{
    graphic_system_need_restart = FALSE;
  }
}



/********************************************************/
/* ѥå						*/
/********************************************************/
#if 1
void	trans_palette( SYSTEM_PALETTE_T syspal[] )
{
  int     i, j, nr_color;
  XColor  color[16 +15+14+13+12+11+10+9+8+7+6+5+4+3+2+1];

		/* 88Υѥå16ʬ */

  for( i=0; i<16; i++ ){
    color[i].pixel = color_pixel[i];
    color[i].red   = (unsigned short)syspal[i].red   << 8;
    color[i].green = (unsigned short)syspal[i].green << 8;
    color[i].blue  = (unsigned short)syspal[i].blue  << 8;
    color[i].flags = DoRed|DoGreen|DoBlue;
  }
  nr_color = 16;


	/*  HALF ǥե륿󥰤ǽå */

  if( screen_size == SCREEN_SIZE_HALF &&
/*    grph_ctrl & GRPH_CTRL_COLOR &&  */
      color_h_pixel_exist  &&  use_half_interp ){
    now_half_interp = TRUE;
  }else{
    now_half_interp = FALSE;
  }

	/* HALFե륿󥰲ǽϥե륿ѥåͤ׻ */
	/* (ե륿Ѥˤϡ120) */

  if( now_half_interp ){
    for( i=0; i<16; i++ ){
      for( j=i+1; j<16; j++ ){
	color[nr_color].pixel = color_half_pixel[i][j];
	color[nr_color].red   = (color[i].red  >>1) + (color[j].red  >>1);
	color[nr_color].green = (color[i].green>>1) + (color[j].green>>1);
	color[nr_color].blue  = (color[i].blue >>1) + (color[j].blue >>1);
	color[nr_color].flags = DoRed|DoGreen|DoBlue;
	nr_color++;
      }
    }
  }




  switch( colormap_type ){
  case -1:
  case 0:			/* ץ饤١ȥ˥顼ž */
  case 1:
    XStoreColors( display, colormap, color, nr_color );
#ifdef	USE_DGA
    if( use_DGA ){
      XF86DGAInstallColormap( display, DefaultScreen(display), colormap);
    }
#endif
    break;

  case 2:			/* Υ顼 ʥ顼 */
    if( color_count ){
      XFreeColors( display, colormap, color_buf, color_count, 0 );
      color_count = 0;
    }

    for( i=0; i<16; i++ ){
      if( !color[i].blue && !color[i].red && !color[i].green ){
	color_pixel[i] = black;
      }
      else
      {
	if( XAllocColor( display, colormap, &color[i] ))
	{
	  color_pixel[i] = color[i].pixel;
	  color_buf[ color_count ++ ] = color[i].pixel;
	}else{
	  color_pixel[i] = black;
	}
      }
    }

    if( now_half_interp ){
      for( i=0; i<16; i++ ){
	color_half_pixel[i][i] = color_pixel[i];
      }
      nr_color = 16;
      for( i=0; i<16; i++ ){
	for( j=i+1; j<16; j++ ){
	  if( XAllocColor( display, colormap, &color[nr_color] ))
	  {
	    color_half_pixel[i][j] = color[nr_color].pixel;
	    color_buf[ color_count ++ ] = color[nr_color].pixel;
	  }else{
	    color_half_pixel[i][j] = black;
	  }
	  color_half_pixel[j][i] = color_half_pixel[i][j];
	  nr_color++;
	}
      }
    }
  }
}



#else		/*------------------------------------- not used */

static	Ulong	color_h_buf[16*16];
static	int	color_h_count;
void	trans_palette( SYSTEM_PALETTE_T syspal[] )
{
  int     i, j;
  XColor  color[16];
  XColor  hcolor[16][16];

  for( i=0; i<16; i++ ){
    color[i].pixel = color_pixel[i];
    color[i].red   = (unsigned short)syspal[i].red   << 8;
    color[i].green = (unsigned short)syspal[i].green << 8;
    color[i].blue  = (unsigned short)syspal[i].blue  << 8;
    color[i].flags = DoRed|DoGreen|DoBlue;
  }


	/*  HALF ǥե륿󥰤ǽå */

  if( screen_size == SCREEN_SIZE_HALF &&
/*    grph_ctrl & GRPH_CTRL_COLOR &&  */
      color_h_pixel_exist  &&  use_half_interp ){
    now_half_interp = TRUE;
  }else{
    now_half_interp = FALSE;
  }

	/* HALFե륿󥰲ǽϥե륿ѥåͤ׻ */

  if( now_half_interp ){
    for( i=0; i<16; i++ ){
      hcolor[i][i] = color[i];
    }
    for( i=0; i<16; i++ ){
      for( j=i+1; j<16; j++ ){
	hcolor[i][j].pixel = color_half_pixel[i][j];
	hcolor[i][j].red   = (color[i].red  >>1) + (color[j].red  >>1);
	hcolor[i][j].green = (color[i].green>>1) + (color[j].green>>1);
	hcolor[i][j].blue  = (color[i].blue >>1) + (color[j].blue >>1);
	hcolor[i][j].flags = DoRed|DoGreen|DoBlue;
	hcolor[j][i] = hcolor[i][j];
      }
    }
  }




  switch( colormap_type ){
  case -1:
  case 0:			/* ץ饤١ȥ˥顼ž */
  case 1:
    XStoreColors( display, colormap, color, 16 );
    if( now_half_interp ){
      XStoreColors( display, colormap, (XColor*)hcolor, 16*16 );
    }
#ifdef	USE_DGA
    if( use_DGA ){
      XF86DGAInstallColormap( display, DefaultScreen(display), colormap);
    }
#endif
    break;

  case 2:			/* Υ顼 ʥ顼 */
    if( color_count ){
      XFreeColors( display, colormap, color_buf, color_count, 0 );
      color_count = 0;
    }
    if( color_h_count ){
      XFreeColors( display, colormap, color_h_buf, color_h_count, 0 );
      color_h_count = 0;
    }

    for( i=0; i<16; i++ ){
      if( !color[i].blue && !color[i].red && !color[i].green ){
	color_pixel[i] = black;
      }
      else
      {
	if( XAllocColor( display, colormap, &color[i] ))
	{
	  color_pixel[i] = color[i].pixel;
	  color_buf[ color_count ++ ] = color[i].pixel;
	}else{
	  color_pixel[i] = black;
	}
      }
    }

    if( now_half_interp ){
      for( i=0; i<16; i++ ){
        for( j=0; j<16; j++ ){
	  if( XAllocColor( display, colormap, &hcolor[i][j] ))
	  {
	    color_half_pixel[i][j] = hcolor[i][j].pixel;
	    color_h_buf[ color_h_count ++ ] = hcolor[i][j].pixel;
	  }else{
	    color_half_pixel[i][j] = black;
	  }
	}
      }
    }
  }
}
#endif		/*------------------------------------- not used */





/************************************************************************/
/* ɽ								*/
/************************************************************************/
void	put_image( void )
{
#ifdef	USE_DGA
  if( !use_DGA )
#endif

  {
#ifdef MITSHM
  if( use_SHM )
  XShmPutImage( display, window, gc, image, 0, 0, 0, 0, WIDTH, HEIGHT,False);
  else
#endif
  XPutImage( display, window, gc, image, 0, 0, 0, 0, WIDTH, HEIGHT );

#if 0
  XFlush( display );
#else
  XSync( display, False );
#endif
  }
}






/************************************************************************/
/* ޥɽɽԤʤؿ					*/
/************************************************************************/
static	char ms_data[8] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
static	Pixmap cursor_pix;
static	Cursor cursor_id;
static	XColor cursor_col;

static	void	alloc_pixmap_for_invisible_mouse( void )
{
  cursor_pix       = XCreateBitmapFromData( display, window, ms_data, 8, 8 );
  cursor_col.pixel = black;
  cursor_id        = XCreatePixmapCursor( display, cursor_pix, cursor_pix,
					  &cursor_col, &cursor_col, 0, 0 );
}
static	void	free_pixmap_for_invisible_mouse( void )
{
  XUndefineCursor( display, window );
  XFreePixmap( display, cursor_pix );
}

void	set_mouse_visible( void )
{
  XUndefineCursor( display, window );
}

void	set_mouse_invisible( void )
{
  XDefineCursor( display, window, cursor_id );
}



/************************************************************************/
/* եåƥ (X11) κƽ				*/
/*	եåƥöλ١Ԥ		*/
/*	äơscreen_size ʤɤѹƤС礭	*/
/*	ɥ뤳Ȥˤʤ롣				*/
/*	ƽ˼ԤȤϡɤ褦ʤΤǡλ롣	*/
/************************************************************************/
void	graphic_system_restart( int redraw_flag )
{
  int	verbose_proc_saved = verbose_proc;
  verbose_proc = 0;


#ifdef	USE_DGA

	  /* ߡDGAǡƽDGA ξ */
  if( use_DGA ){

    if( restart_DGA ){		/* ѹϡñɽϰ֤Ѥ */

      if( screen_size > screen_size_max ){
	screen_size = screen_size_max;
      }
      SCREEN_W = screen_size_tbl[screen_size].w;
      SCREEN_H = screen_size_tbl[screen_size].h;
      SCREEN_OFFSET = WIDTH - SCREEN_W;
      SCREEN_DX = ( ( WIDTH - SCREEN_W ) / 2 ) & ~7;	/* 8ܿ */
      SCREEN_DY = ( ( HEIGHT- SCREEN_H ) / 2 ) & ~1;	/* 2ܿ */

      screen_buf = dga_addr;
      screen_start = &screen_buf[ (WIDTH*SCREEN_DY+SCREEN_DX) *SIZE_OF_DEPTH ];

      screen_buf_init();

      if( redraw_flag ) redraw_screen( FALSE );

      verbose_proc = verbose_proc_saved;
      return;


	/* ߡDGAǡƽ noDGA ξ */

    }else{

      graphic_system_need_restart = TRUE;
      graphic_system_term();		/* DGA λ	*/
      use_DGA = FALSE;			/* DGA Ѥ	*/
      WIDTH  = 0;	HEIGHT = 0;	/* 	*/
      goto GRAPHIC_SYSTEM_INIT;		/* 	*/
    
    }

  }else{

	/* ߡnoDGAǡƽ DGA ξ */

    if( restart_DGA && enable_DGA ){	/* DGAǵưȤΤOK */

      graphic_system_need_restart = TRUE;
      graphic_system_term();		/* X11 λ	*/
      use_DGA = TRUE;			/* DGA Ѥ	*/
      WIDTH  = 0;	HEIGHT = 0;	/* 	*/
      goto GRAPHIC_SYSTEM_INIT;		/* 	*/


	/* ߡnoDGAǡƽ noDGA ξ */

    }else{
      restart_DGA = FALSE;
    }
  }

#endif



  /* եåƥöλ */
  graphic_system_need_restart = TRUE;
  graphic_system_term();



  /* ɥˡܡΥƱˤʤ褦ˤ */

  WIDTH  = SCREEN_DX * 2 + screen_size_tbl[screen_size].w;
  HEIGHT = SCREEN_DY * 2 + screen_size_tbl[screen_size].h;



GRAPHIC_SYSTEM_INIT:

  if( graphic_system_init() ){

    verbose_proc = verbose_proc_saved;
    if( redraw_flag ) redraw_screen( FALSE );

  }else{

    fprintf(stderr,"Sorry : Graphic System Fatal Error !!!\n");

    verbose_proc = verbose_proc_saved;
    main_exit(-1);

  }
}
