/************************************************************************/
/*									*/
/* ߤΥߥ졼						*/
/*									*/
/************************************************************************/

#include "quasi88.h"
#include "initval.h"
#include "intr.h"

#include "pc88cpu.h"
#include "screen.h"
#include "keyboard.h"
#include "sound.h"
#include "joystick.h"

#include "emu.h"
#include "snddrv.h"
#include "wait.h"
#include "suspend.h"



int	intr_level;			/* OUT[E4] ߥ٥	*/
int	intr_priority;			/* OUT[E4] ͥ	*/
int	intr_sio_enable;		/* OUT[E6] ߥޥ SIO	*/ 
int	intr_vsync_enable;		/* OUT[E6] ߥޥ VSYNC	*/ 
int	intr_rtc_enable;		/* OUT[E6] ߥޥ RTC	*/ 



double	cpu_clock_mhz   = DEFAULT_CPU_CLOCK_MHZ;   /* MAIN CPU Clock   [MHz] */
double	sound_clock_mhz = DEFAULT_SOUND_CLOCK_MHZ; /* SOUND chip Clock [MHz] */
double	vsync_freq_hz   = DEFAULT_VSYNC_FREQ_HZ;   /* VSYNC    [Hz]  */



#define	CPU_CLOCK_MHZ		cpu_clock_mhz
#define	SOUND_CLOCK_MHZ		sound_clock_mhz
#define	VSYNC_FREQ_HZ		vsync_freq_hz

#define	VRTC_RATE		(48.0/448.0)
#define	RTC_FREQ_HZ		(600)

#define	TIMER_A_CONST		(12)
#define	TIMER_B_CONST		(192)

#define	CPU_CLOCK		(CPU_CLOCK_MHZ * 1000000)

/*****************************************************************************/

int	state_of_cpu = 0;		/* ᥤCPU̿	*/
int	state_of_vsync;			/* VSYNCΥơȿ	*/

int	cpu_load      = 0;		/*  ۤ٤	*/
int	no_wait	      = FALSE;		/* Ȥʤ			*/


	int	RS232C_flag    = FALSE;	/* RS232C */
static	int	rs232c_intr_base;
static	int	rs232c_intr_timer;

	int	VSYNC_flag     = FALSE;	/* VSYNC */
static	int	vsync_intr_base;
static	int	vsync_intr_timer;

	int	ctrl_vrtc      = 1;	/* VRTC (ľ:1 / ɽ:0) */
static	int	vrtc_base;
static	int	vrtc_timer;

	int	RTC_flag       = FALSE;	/* RTC */
static	int	rtc_intr_base;
static	int	rtc_intr_timer;

	int	SOUND_flag     = FALSE;	/* SOUND Timer-A/Timer-B */
static	int	sd_A_intr_base;
static	int	sd_A_intr_timer;
static	int	sd_B_intr_base;
static	int	sd_B_intr_timer;
static	int	sd2_BRDY_intr_base;
static	int	sd2_BRDY_intr_timer;
static	int	sd2_EOS_intr_base;
static	int	sd2_EOS_intr_timer;




/*------------------------------------------------------
 * ޡߥߥ졼ȤΥ
 *	VSYNC / VRTC / RTC         ϵư˽
 *	RS232C / Timer-A / TImer-B ˽
 *------------------------------------------------------*/

/*
 * ߥߥ졼Ƚ  Z80 εư˸Ƥ
 */
static	void	interval_work_init_generic( void )
{
  vsync_intr_timer = vsync_intr_base = CPU_CLOCK / VSYNC_FREQ_HZ;
  vrtc_timer       = vrtc_base       = (vsync_intr_base * VRTC_RATE);

  rtc_intr_timer   = rtc_intr_base   = CPU_CLOCK / RTC_FREQ_HZ;

  select_main_cpu = TRUE;
  dual_cpu_count  = 0;

  state_of_vsync = vsync_intr_base;
  state_of_cpu   = 0;
}


/*
 * RS232Cߥߥ졼Ƚ  Z80ưRS232C˸Ƥ
 */
static	void	interval_work_init_RS232C( void )
{
  double	bps = 300;	/*9600;*/		/* ܡ졼 */
  double	bitwidth = (1+8+1);	/* STARTbit + bitĹ + STOPbit */

  rs232c_intr_timer = rs232c_intr_base = CPU_CLOCK / ( bps / bitwidth );
}

/*
 * ɳߥߥ졼Ƚ  Z80ư˸Ƥ
 */
static	void	interval_work_init_TIMER_A( void )
{
  interval_work_set_TIMER_A();
  sd_A_intr_timer = sd_A_intr_base;
}
static	void	interval_work_init_TIMER_B( void )
{
  interval_work_set_TIMER_B();
  sd_B_intr_timer = sd_B_intr_base;
}




/*
 * ߥߥ졼Ƚ  Z80ư䡢åѹʤɤ˸Ƥ
 */
void	interval_work_init_all( void )
{
  interval_work_init_generic();
  interval_work_init_RS232C();
  interval_work_init_TIMER_A();
  interval_work_init_TIMER_B();
}







/************************************************************************/
/* ߤ˴ؤ ɥ쥸ν			*/
/************************************************************************/
/*
 * ɤΥޥץꥻå ѹ˸Ƥ
 */
void	interval_work_set_TIMER_A( void )
{
  sd_A_intr_base  = TIMER_A_CONST * sound_prescaler * (1024 - sound_TIMER_A)
					* ( CPU_CLOCK_MHZ / SOUND_CLOCK_MHZ );
}
void	interval_work_set_TIMER_B( void )
{
  sd_B_intr_base  = TIMER_B_CONST * sound_prescaler * (256 - sound_TIMER_B)
					* ( CPU_CLOCK_MHZ / SOUND_CLOCK_MHZ );
}

/*
 * ɤ Ƽե饰  ץꥹ顼ѹ˸Ƥ
 */
static	int	sound_flags_update     = 0;
static	int	sound_prescaler_update = 0;

void	change_sound_flags( int port )
{
  sound_flags_update = (int)port;
  refresh_intr_timing( z80main_cpu );
}
void	change_sound_prescaler( int new_prescaler )
{
  sound_prescaler_update = new_prescaler;
  refresh_intr_timing( z80main_cpu );
}




/*
 * ɤΥץꥹ顼͡Ƽե饰ѹκݤˡե饰롣
 *	߹˸ƤФ롣
 */
static	void	check_sound_parm_update( void )
{
  byte data;

  if( sound_prescaler_update ){		/* ʬ ѹä		    */
					/* ͤ (ѹ/ѹ)ܤ */
					/* ͤΤĤĤޤ򤢤碌롣   */
    sd_A_intr_base  = sd_A_intr_base  * sound_prescaler_update/sound_prescaler;
    sd_A_intr_timer = sd_A_intr_timer * sound_prescaler_update/sound_prescaler;
    sd_B_intr_base  = sd_B_intr_base  * sound_prescaler_update/sound_prescaler;
    sd_B_intr_timer = sd_B_intr_timer * sound_prescaler_update/sound_prescaler;
    sound_prescaler = sound_prescaler_update;
    sound_prescaler_update = 0;
  }


  switch( sound_flags_update ){		/* ե饰ѹä顢 */

  case 0x27:		/*---------------- RESET_B/A | ENABLE_B/A | LOAD_B/A */
    data = sound_reg[0x27];

					/* LOADΩ夬ˡ͹ */
    if( (sound_LOAD_A==0) && (data&0x01) ) sd_A_intr_timer = sd_A_intr_base;
    if( (sound_LOAD_B==0) && (data&0x02) ) sd_B_intr_timer = sd_B_intr_base;
    sound_LOAD_A = data & 0x01;
    sound_LOAD_B = data & 0x02;

					/* ENABLE ¸ */
    sound_ENABLE_A = ( data & 0x04 ) ? 1 : 0;
    sound_ENABLE_B = ( data & 0x08 ) ? 1 : 0;

					/* RESET  1 ʤ顢ե饰ꥢ */
    if( data & 0x10 ) sound_FLAG_A = 0;
    if( data & 0x20 ) sound_FLAG_B = 0;
    break;

  case 0x29:		/*---------------- EN_ZERO/BRDY/EOS/TB/TA  */
    if( sound_board==SOUND_II ){
      data = sound_reg[0x29];
      sound2_EN_TA   = data & 0x01;
      sound2_EN_TB   = data & 0x02;
      sound2_EN_EOS  = data & 0x04;
      sound2_EN_BRDY = data & 0x08;
      sound2_EN_ZERO = data & 0x10;
    }
    break;

  case 0x10:		/*---------------- IRQ_RET | MSK_ZERO/BRDY/EOS/TB/TA */
    data = sound2_reg[0x10];
    if( data & 0x80 ){
      sound_FLAG_A     = 0;
      sound_FLAG_B     = 0;
      sound2_FLAG_EOS  = 0;
      sound2_FLAG_BRDY = 0;
      sound2_FLAG_ZERO = 0;
    }else{
      sound2_MSK_TA   = data & 0x01;
      sound2_MSK_TB   = data & 0x02;
      sound2_MSK_EOS  = data & 0x04;
      sound2_MSK_BRDY = data & 0x08;
      sound2_MSK_ZERO = data & 0x10;
    }
    break;

  }

  sound_flags_update = 0;

}


/*
 * ɥܡIIϢ
 */
void	interval_work_set_BDRY( void )
{
  sd2_BRDY_intr_base  = sound2_intr_base * 2 * ( CPU_CLOCK_MHZ / 4.0 );
  sd2_BRDY_intr_timer = sd2_BRDY_intr_base;

/*printf("%d\n",sd2_BRDY_intr_base);*/
}
void	interval_work_set_EOS( int length )
{
  sd2_EOS_intr_base  = sd2_BRDY_intr_base * length;
  sd2_EOS_intr_timer = sd2_EOS_intr_base;

/*printf("%d\n",sd2_EOS_intr_base);*/
}



/************************************************************************/
/* 1/60 sec γ˹Ԥʤ					*/
/************************************************************************/

/* #define ȡVSYNCϻɽ#undef VBLANK λɽ */
#undef	DRAW_SCREEN_AT_VSYNC_START

static	void	vsync( void )
{
  xmame_sound_update();			/* ɽ */

  if( !no_wait ) wait_vsync();		/* »֤ǥȤ */


  xmame_update_video_and_audio();	/* ɽ 2 */

  scan_joystick();                      /* Joystick  */
  scan_keyboard(0);			/* 	*/
  scan_mouse();				/* ޥ	*/
  scan_expose();
#ifdef	DRAW_SCREEN_AT_VSYNC_START
  draw_screen();			/* ̽	*/
#endif

  scan_focus();				/* ɥեå	*/


  state_of_cpu -= state_of_vsync;	/* (== vsync_intr_base) */
}






/*----------------------------------------------------------------------*/
/* ߤ롣ƱˡγߤޤǤΡǾ state ׻	*/
/*	ͤϡZ80λΥե饰(TRUE/FALSE)			*/
/*----------------------------------------------------------------------*/
#define	MIN(x,y)	(((x)<(y))?(x):(y))
int	main_INT_update( void )
{

  int	icount = rtc_intr_base;		/* γȯޤǤκǾstate */
					/* ȤꤢRTCμǽ */


#if 0
		/* -------- RS232C  -------- */

  rs232c_intr_timer -= z80main_cpu.state;
  if( rs232c_intr_timer < 0 ){
    rs232c_intr_timer += rs232c_intr_base;
    if( sio_intr() ){
      RS232C_flag = TRUE;
    }
  }
  icount = MIN( icount, rs232c_intr_timer );
#endif

		/* -------- VSYNC  -------- */

  state_of_cpu += z80main_cpu.state;

  vsync_intr_timer -= z80main_cpu.state;
  if( vsync_intr_timer < 0 ){
    vsync();					/* ȡɽ */
    ctrl_vrtc  = 1;				/* VBLANK */
    VSYNC_flag = TRUE;
    vsync_intr_timer += vsync_intr_base;
  }
  icount = MIN( icount, vsync_intr_timer );


		/* -------- VRTC  -------- */

  if( ctrl_vrtc ){
    if( vrtc_timer < 0 ){
      vrtc_timer = vrtc_base;
    }else{
      vrtc_timer -= z80main_cpu.state;
      if( vrtc_timer < 0 ){
	ctrl_vrtc  = 0;				/* VBLANK λ */
	/*VSYNC_flag = FALSE;*/			/* VSYNCOFFʤ */
		/* OFFȸ껦ͻȤưʤ   thanks peach ! */
#ifndef	DRAW_SCREEN_AT_VSYNC_START
	draw_screen();				/* ̽	*/
#endif
      }
    }
  }
  if( ctrl_vrtc ) icount = MIN( icount, vrtc_timer );


		/* -------- RTC  -------- */

  rtc_intr_timer -= z80main_cpu.state;
  if( rtc_intr_timer < 0 ){
    RTC_flag = TRUE;
    rtc_intr_timer += rtc_intr_base;
  }
  icount = MIN( icount, rtc_intr_timer );


		/* -------- SOUND TIMER A  -------- */

  if( sound_LOAD_A ){
    sd_A_intr_timer -= z80main_cpu.state;
    if( sd_A_intr_timer < 0 ){
      xmame_sound_timer_over(0);
      sd_A_intr_timer += sd_A_intr_base;
      if( sound_ENABLE_A ){
	if( sound2_MSK_TA ) sound_FLAG_A = 0;
	else                sound_FLAG_A = 1;
	if( sound_FLAG_A && sound2_EN_TA ) SOUND_flag = TRUE;
      }
    }
    icount = MIN( icount, sd_A_intr_timer );
  }


		/* -------- SOUND TIMER B  -------- */

  if( sound_LOAD_B ){
    sd_B_intr_timer -= z80main_cpu.state;
    if( sd_B_intr_timer < 0 ){
      xmame_sound_timer_over(1);
      sd_B_intr_timer += sd_B_intr_base;
      if( sound_ENABLE_B ){
	if( sound2_MSK_TB ) sound_FLAG_B = 0;
	else                sound_FLAG_B = 1;
	if( sound_FLAG_B && sound2_EN_TB ) SOUND_flag = TRUE;
      }
    }
    icount = MIN( icount, sd_B_intr_timer );
  }

  if( sound2_FLAG_PCMBSY ){

    sd2_BRDY_intr_timer -= z80main_cpu.state;
    if( sd2_BRDY_intr_timer < 0 ){
      sd2_BRDY_intr_timer += sd2_BRDY_intr_base;
      {
	if( sound2_MSK_BRDY ) sound2_FLAG_BRDY = 0;
	else                  sound2_FLAG_BRDY = 1;
	if( sound2_FLAG_BRDY && sound2_EN_BRDY ) SOUND_flag = TRUE;
      }
    }

    if( sound2_notice_EOS ){
      sd2_EOS_intr_timer -= z80main_cpu.state;
      if( sd2_EOS_intr_timer < 0 ){
	sd2_EOS_intr_timer += sd2_EOS_intr_base;
	if( sound2_MSK_EOS ) sound2_FLAG_EOS = 0;
	else                 sound2_FLAG_EOS = 1;
	if( sound2_FLAG_EOS && sound2_EN_EOS ) SOUND_flag = TRUE;
	if( !sound2_repeat )  sound2_FLAG_PCMBSY = 0;
	sound2_notice_EOS = FALSE;
      }
    }

  }


	/* ɤΡߤ˴ؤ쥸ѹƤʤǧ */

  check_sound_parm_update();


	/* γȯޤǤΡơȿ򥻥å */

  if( cpu_load ) icount = MIN( icount, cpu_load );

  z80main_cpu.icount = icount;
  z80main_cpu.state  = 0;


	/* Ctrl-C 䡢F12 Ϥκݤϡ */

  if( dual_cpu_count ){ dual_cpu_count--; return 1; }

  if( emu_mode!=EXECUTE ) return 1;
  else                    return 0;
}






/************************************************************************/
/* ޥ֥ߥߥ졼					*/
/************************************************************************/
/*--------------------------------------*/
/*  (Z80ꥻåȻ˸Ƥ)		*/
/*--------------------------------------*/
void	main_INT_init( void )
{
  RS232C_flag  = FALSE;
  VSYNC_flag   = FALSE;
  RTC_flag     = FALSE;
  SOUND_flag   = FALSE;

  interval_work_init_all();
  ctrl_vrtc = 1;

/*
printf("CPU    %f\n",cpu_clock_mhz);
printf("SOUND  %f\n",sound_clock_mhz);
printf("SYNC   %f\n",vsync_freq_hz);
printf("RS232C %d\n",rs232c_intr_base);
printf("VSYNC  %d\n",vsync_intr_base);
printf("VRTC   %d\n",vrtc_base);
printf("RTC    %d\n",rtc_intr_base);
printf("A      %d\n",sd_A_intr_base);
printf("B      %d\n",sd_B_intr_base);
*/
}

/*----------------------------------------------*/
/* å (Ļ 1ƥå˸ƤФ)	*/
/*						*/
/*	棱IM!=2 λϳߤϤɤʤ롩	*/
/*	棲intr_priority λϡ	*/
/*	      ߾֤Ϥɤʤ롩		*/
/*		  (̵)			*/
/*						*/
/*----------------------------------------------*/
int	main_INT_chk( void )
{
  int	intr_no = -1;

  /*  if( z80main_cpu.IM!=2 ) return -1;*/


  if( intr_level==0 ){				/* ٥ 0 */
    {						/*    ߤϼդʤ */
      intr_no = -1;
    }
  }
  else if( intr_level>=1 &&			/* ٥ 1 */
	   intr_sio_enable && RS232C_flag ){	/*    RS232S   */
    intr_no = 0;
  }
  else if( intr_level>=2 &&			/* ٥ 2 */
	   intr_vsync_enable && VSYNC_flag ){	/*    VSYNC  */
    VSYNC_flag = FALSE;
    intr_no = 1;
  }
  else if( intr_level>=3 &&			/* ٥ 3 */
	   intr_rtc_enable && RTC_flag ){	/*    1/600 RTC  */
    RTC_flag = FALSE;
    intr_no = 2;
  }
  else if( intr_level>=5 &&			/* ٥ 5 */
	   intr_sound_enable && SOUND_flag ){	/*    SOUND TIMER  */
    SOUND_flag = FALSE;
    intr_no = 4;
  }


  if( intr_no >= 0 ){
    if( intr_priority ) intr_level = 7;
    else                intr_level = intr_no;
    return intr_no;
  }else{
    return -1;
  }
}








/****************************************************************/	
/* ڥɡ쥸塼					*/
/****************************************************************/	
static	T_SUSPEND_W	suspend_intr_work[]=
{
  { TYPE_INT,	&intr_level,		},
  { TYPE_INT,	&intr_priority,		},
  { TYPE_INT,	&intr_sio_enable,	},
  { TYPE_INT,	&intr_vsync_enable,	},
  { TYPE_INT,	&intr_rtc_enable,	},

  { TYPE_DOUBLE,&cpu_clock_mhz,		},
  { TYPE_DOUBLE,&sound_clock_mhz,	},
  { TYPE_DOUBLE,&vsync_freq_hz,		},

  { TYPE_INT,	&state_of_cpu,		},
  { TYPE_INT,	&state_of_vsync,	},

  { TYPE_INT,	&cpu_load,		},
  { TYPE_INT,	&no_wait,		},

  { TYPE_INT,	&RS232C_flag,		},
  { TYPE_INT,	&rs232c_intr_base,	},
  { TYPE_INT,	&rs232c_intr_timer,	},

  { TYPE_INT,	&VSYNC_flag,		},
  { TYPE_INT,	&vsync_intr_base,	},
  { TYPE_INT,	&vsync_intr_timer,	},

  { TYPE_INT,	&ctrl_vrtc,		},
  { TYPE_INT,	&vrtc_base,		},
  { TYPE_INT,	&vrtc_timer,		},

  { TYPE_INT,	&RTC_flag,		},
  { TYPE_INT,	&rtc_intr_base,		},
  { TYPE_INT,	&rtc_intr_timer,	},

  { TYPE_INT,	&SOUND_flag,		},
  { TYPE_INT,	&sd_A_intr_base,	},
  { TYPE_INT,	&sd_A_intr_timer,	},
  { TYPE_INT,	&sd_B_intr_base,	},
  { TYPE_INT,	&sd_B_intr_timer,	},

  { TYPE_INT,	&sound_flags_update,	},
  { TYPE_INT,	&sound_prescaler_update,},

  { TYPE_INT,	&sd2_BRDY_intr_base,	},
  { TYPE_INT,	&sd2_BRDY_intr_timer,	},
  { TYPE_INT,	&sd2_EOS_intr_base,	},
  { TYPE_INT,	&sd2_EOS_intr_timer,	},
};


int	suspend_intr( FILE *fp, long offset )
{
  int	ret = suspend_work( fp, offset, 
			    suspend_intr_work, 
			    countof(suspend_intr_work) );

  if( ret<0 ) return FALSE;

  if( verbose_suspend )
    printf( "suspend <%s>: %d byte\n", __FILE__, ret );
  if( (int)sizeof( ((suspend_0*)0)->intr ) < ret ){
    fprintf( stderr, "SUSPEND ERROR : Size Overflow in <%s>\n",__FILE__);
    main_exit(4);
  }

  return TRUE;
}


int	resume_intr(  FILE *fp, long offset )
{
  int	ret = resume_work( fp, offset, 
			   suspend_intr_work, 
			   countof(suspend_intr_work) );

  if( ret<0 ) return FALSE;
  return TRUE;
}



void	main_INT_init_at_resume( void )
{
  /* 쥸塼κƽ */
  /*  ġġ ʤΤ */
}
