/************************************************************************/
/*									*/
/* ߽ (OS¸)						*/
/*									*/
/*	ѿ pause_by_focus_out ˤѤ			*/
/*	pause_by_focus_out == 0 λ					*/
/*		ESCȲ	 PAUSEɽ		*/
/*	pause_by_focus_out != 0 λ					*/
/*		X ΥޥȲ				*/
/*									*/
/* ڴؿ								*/
/* void pause_init( void )						*/
/*									*/
/* void pause_main( void )						*/
/*									*/
/************************************************************************/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "quasi88.h"
#include "pause.h"

#include "emu.h"
#include "initval.h"
#include "indicator.h"
#include "graph.h"
#include "screen.h"
#include "device.h"
#include "snddrv.h"


int	pause_by_focus_out = FALSE;


void	pause_quit_signal( void )
{
  XClientMessageEvent E;

  E.type    = ClientMessage;
  E.display = display;
  E.window  = window;
  E.message_type = atom_sigint;
  E.format       = 32;

  if( XSendEvent( display, window, False, ExposureMask, (XEvent*)&E ) ){
    XFlush( display );
  }
}


void	pause_init( void )
{
  xmame_sound_suspend();
}


void	pause_main( void )
{
  XEvent E;
  int	i;
  int	exit_flag = FALSE;
  int	display_flag = (pause_by_focus_out) ? FALSE : TRUE;


  XAutoRepeatOn( display );

  XUngrabPointer (display, CurrentTime);

  indicate_change_pause();

  redraw_screen( display_flag );


  while( exit_flag == FALSE ){

    XNextEvent( display, &E );

    switch( E.type ){

    case ClientMessage:
      if(       E.xclient.message_type == atom_WM_close_type &&
	  (Atom)E.xclient.data.l[0]    == atom_WM_close_data ){
	if( verbose_proc ) printf( "Window Closed.....\n" );
	main_exit(1);
      }else
      if( E.xclient.message_type == atom_sigint ){	/* Ctrl-C н */
	exit_flag = TRUE;
      }
      break;

    case Expose:
      redraw_screen( display_flag );
      break;

    case KeyPress:
      if( pause_by_focus_out == FALSE ){
	i = XLookupKeysym( (XKeyEvent *)&E, 0 );

	if( i==XK_Escape ){

	  exit_flag = TRUE;
	  if( check_break_point_PC() ) emu_mode = EXECUTE_BP;
	  else                         emu_mode = EXECUTE;

	}else if( i==XK_F12 ){

	  exit_flag = TRUE;
	  emu_mode = MENU;

	}
      }
      break;

    case FocusIn:
      if( pause_by_focus_out ){
	if( check_break_point_PC() ) emu_mode = EXECUTE_BP;
	else                         emu_mode = EXECUTE;
	exit_flag = TRUE;
      }
      break;

    }
  }

	/* ¸Υ٥Ȥ򤹤٤˴ */

  while( XCheckWindowEvent( display, window,
			   ExposureMask|KeyPressMask|KeyReleaseMask|
			   ButtonPressMask|ButtonReleaseMask|PointerMotionMask,
			   &E) );

  XAutoRepeatOff( display );

  if( grab_mouse ){
    XGrabPointer( display, window, True, 0, GrabModeAsync, GrabModeAsync, 
		  window, None, CurrentTime );
  }

  indicator_flag = ( indicator_flag & ~INDICATE_MES_MASK );
  redraw_screen( FALSE );


  pause_by_focus_out = FALSE;

  xmame_sound_resume();
}
