/************************************************************************/
/*									*/
/* PIO  								*/
/*									*/
/************************************************************************/

#include <stdio.h>

#include "quasi88.h"
#include "pio.h"

#include "pc88cpu.h"

#include "emu.h"
#include "suspend.h"


/* PIO ˤ롢CPU ؤ					*/
/*	  PC88 ǤϡᥤCPU (¦) ȥCPU (ǥ¦)Ȥˡ	*/
/*	줾CPU äƤ롣̾Ϥɤ餫Τߤ򥨥ߥ졼	*/
/*	PIO Υäˡ¦CPUؤ롣	*/
/*	ˤꡢߥ졼Ȥν®٤夲Ƥ롣			*/
/*									*/
/*	  CPUؤߥ󥰤̾ϡPIO  CݡȤ꡼	*/
/*	Τߤ˹ԤʤPIO  CݡȤϡA ޤ B ݡȤ	*/
/*	κݤˡǡνɤ߹ߤδλ򼨤ե饰Ȥꤹ	*/
/*	ݡȤǤ롣							*/
/*		(-cpu 0 ץꤷϾ嵭ư򤹤)	*/
/*									*/
/*	  ˤ CݡȤ𤵤ˡǡΥ꡼/饤ȤԤ	*/
/*	եȤ¸ߤ롣(2ĤCPUν®٤Ʊ˰¸Ƥ)	*/
/*	äեȤкȤơA/B/C ݡȤΤ줫˥ᥤCPU	*/
/*	 (ɸǤ 256ƥå)CPU	*/
/*	˽褦ˤ					*/
/*		(-cpu 1 ץꤷϾ嵭ư򤹤)	*/
/*									*/
/*	  ǤޤưʤեȤ롣CPUν®٤˰¸Ƥ	*/
/*	Τ ǾᥤCPUȥCPU˽	*/
/*	ߤƤߤ							*/
/*		(-cpu 2 ץꤷϾ嵭ư򤹤)	*/
/*									*/
/*	  ʤưʤեȤͭ롣ǡᥤCPUȥCPU	*/
/*	˽뤬A/B ݡȥ꤬ݡȥ	*/
/*	ʤϡ֥ȤȤ褦ˤƤߤ		*/
/*		(-cpu 3 ץꤷϾ嵭ư򤹤)	*/

/*---------------------------------------------------------------------------*/
/* 									     */
/*					A  ######## --\/-- ######## A	     */
/*	饤ȤϼʬΥ	B  ######## --/\-- ######## B	     */
/*	  ФƹԤʤ		CH ####     --\/-- ####	    CH	     */
/*	꡼ɤΥ		CL     #### --/\--     #### CL	     */
/*	  Ԥʤ							     */
/*	  ʬΥREADʤ顢					     */
/*	  ʬΥɤࡣ						     */
/*	Ϣ³꡼ɡϢ³饤Ȥ㳰Ԥʤ			     */
/*	ݡCΥ꡼ɥ饤Ȼ㳰Ԥʤ			     */
/*---------------------------------------------------------------------------*/


pio_work	pio_AB[2][2], pio_C[2][2];


static	z80arch	*z80[2] = { &z80main_cpu, &z80sub_cpu };


#define	PIO_CHG_CNT		(16)


/*----------------------------------------------------------------------*/
/* PIO 								*/
/*	PA / PCL   PB / PCH 					*/
/*----------------------------------------------------------------------*/
void	pio_init( void )
{
  int	side;

  for( side=0; side<2; side++ ){
    pio_AB[ side ][ PIO_PORT_A ].type    = PIO_READ;
    pio_AB[ side ][ PIO_PORT_A ].exist   = PIO_EMPTY;
    pio_AB[ side ][ PIO_PORT_A ].chg_cnt = PIO_CHG_CNT;
    pio_AB[ side ][ PIO_PORT_A ].data    = 0x00;

    pio_AB[ side ][ PIO_PORT_B ].type    = PIO_WRITE;
    pio_AB[ side ][ PIO_PORT_B ].exist   = PIO_EMPTY;
    pio_AB[ side ][ PIO_PORT_B ].chg_cnt = PIO_CHG_CNT;
    pio_AB[ side ][ PIO_PORT_B ].data    = 0x00;

    pio_C[ side ][ PIO_PORT_CH ].type    = PIO_WRITE;
    pio_C[ side ][ PIO_PORT_CH ].chg_cnt = 1;
    pio_C[ side ][ PIO_PORT_CH ].data    = 0x00;

    pio_C[ side ][ PIO_PORT_CL ].type    = PIO_READ;
    pio_C[ side ][ PIO_PORT_CL ].chg_cnt = 1;
    pio_C[ side ][ PIO_PORT_CL ].data    = 0x00;
  }

}


/* verbose Υåɽޥ					*/

#define	pio_mesAB( s )							\
	if( verbose_pio )						\
	  printf( s " : side = %s : port = %s\n",			\
		 (side==PIO_SIDE_M)?"M":"S", (port==PIO_PORT_A)?"A":"B" )

#define	pio_mesC( s )							\
	if( verbose_pio )						\
	  printf( s " : side = %s\n",					\
		 (side==PIO_SIDE_M)?"M":"S" )

/*----------------------------------------------------------------------*/
/* PIO A or B ꡼						*/
/*	꡼ɤκݤΥǡϡ¦դΥݡȤɤ߽Ф	*/
/*		ΥݡȤ꤬  READ ʤ饨顼ɽ		*/
/*		ʬΥݡȤ꤬ WRITE ʤ饨顼ɽ		*/
/*		Ϣ³꡼ɤκݤϡ󥿤򥫥ȥ󤹤롣	*/
/*			󥿤 0 ʤơϢ³꡼ɤ롣	*/
/*			󥿤 1 ʾʤ顢CPU ؤ롣		*/
/*----------------------------------------------------------------------*/
byte	pio_read_AB( int side, int port )
{
		/* ݡ°԰ */

  if( pio_AB[ side^1 ][ port^1 ].type == PIO_READ  ){	/* ݡȤ READ */
    pio_mesAB( "PIO AB READ PORT Mismatch" );
  }
  if( pio_AB[ side   ][ port   ].type == PIO_WRITE ){	/* ʬݡȤ WRITE*/
    pio_mesAB( "PIO Read from WRITE-PORT" );
    pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
    return (pio_AB[ side ][ port ].data);
  }
		/* ɤߤ */

  if( pio_AB[ side^1 ][ port^1 ].exist == PIO_EXIST ){	/* -- ǽɤߤ */

    pio_AB[ side^1 ][ port^1 ].exist   = PIO_EMPTY;
    pio_AB[ side   ][ port   ].chg_cnt = PIO_CHG_CNT;

  }else{						/* -- Ϣ³ɤߤ */

    switch( cpu_timing ){
    case 1:						/*     1:CPUư */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	set_cpu_dormant( z80main_cpu );
      } /*No Break*/
    case 0:						/*     0:Τޤɤ*/
    case 2:						/*     2:Τޤɤ*/
      pio_mesAB( "PIO Read continuously" );
      pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      break;
    case 3:						/*     3:Ф*/
      if( -- pio_AB[ side ][ port ].chg_cnt ){
	z80[side]->discontinue = TRUE;
      }else{
	pio_mesAB( "PIO Read continuously" );
	pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      }
      break;
    default:						/*    -1:CPUؤ*/
      if( -- pio_AB[ side ][ port ].chg_cnt ){
	select_main_cpu ^= 1;
	z80[side]->discontinue = TRUE;
	/*z80sub_cpu.state = 0;*/
      }else{
	pio_mesAB( "PIO Read continuously" );
	pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      }
      break;
    }

  }
  return (pio_AB[ side^1 ][ port^1 ].data);
}


/*----------------------------------------------------------------------*/
/* PIO A or B ˥饤							*/
/*	饤Ȥϡʬ¦ʬΥݡȤФƹԤʤ		*/
/*		ΥݡȤ꤬ WRITE ʤ饨顼ɽ		*/
/*		ʬΥݡȤ꤬  READ ʤ饨顼ɽ		*/
/*		Ϣ³饤Ȥκݤϡ󥿤򥫥ȥ󤹤롣	*/
/*			󥿤 0 ʤơϢ³饤Ȥ롣	*/
/*			󥿤 1 ʾʤ顢CPU ؤ롣		*/
/*----------------------------------------------------------------------*/
void	pio_write_AB( int side, int port, byte data )
{
		/* ݡ°԰ */

  if( pio_AB[ side^1 ][ port^1 ].type == PIO_WRITE ){	/* Υݡ WRITE*/
    pio_mesAB( "PIO AB Write PORT Mismatch" );
  }
  if( pio_AB[ side   ][ port   ].type == PIO_READ ){	/* ʬΥݡ READ */
    pio_mesAB( "PIO Write to READ-PORT" );
  }
		/* 񤭹 */

  if( pio_AB[ side ][ port ].exist == PIO_EMPTY ){	/* -- ǽν񤭹 */

    pio_AB[ side ][ port ].exist   = PIO_EXIST;
    pio_AB[ side ][ port ].data    = data;
    pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;

  }else{						/* -- Ϣ³ν񤭹 */

    switch( cpu_timing ){
    case 1:						/*     1:CPUư */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	set_cpu_dormant( z80main_cpu );
      } /*No Break*/
    case 0:						/*     0:Τޤ޽*/
    case 2:						/*     2:Τޤ޽*/
      pio_mesAB( "PIO Write continuously" );
      pio_AB[ side ][ port ].data    = data;
      pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      break;
    case 3:						/*     3:Ф*/
      if( -- pio_AB[ side ][ port ].chg_cnt ){
	z80[side]->discontinue = TRUE;
	break;
      }else{
	pio_mesAB( "PIO Write continuously" );
	pio_AB[ side ][ port ].data    = data;
	pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      }
      break;
    default:						/*    -1:CPUؤ */
      if( -- pio_AB[ side ][ port ].chg_cnt ){
	select_main_cpu ^= 1;
	z80[side]->discontinue = TRUE;
	/*z80sub_cpu.state = 0;*/
      }else{
	pio_mesAB( "PIO Write continuously" );
	pio_AB[ side ][ port ].data    = data;
	pio_AB[ side ][ port ].chg_cnt = PIO_CHG_CNT;
      }
      break;
    }

  }
  return;
}








/*----------------------------------------------------------------------*/
/* PIO C ꡼							*/
/*	꡼ɤκݤΥǡϡ¦դΥݡȤɤ߽Ф	*/
/*		ΥݡȤ꤬  READ ʤ饨顼ɽ		*/
/*		ʬΥݡȤ꤬ WRITE ʤ饨顼ɽ		*/
/*		꡼ɤκݤˡCPUؤȽ			*/
/*----------------------------------------------------------------------*/
byte	pio_read_C( int side )
{
  byte	data;

		/* ݡ°԰ */
  if( pio_C[ side^1 ][ PIO_PORT_CH ].type == PIO_READ  &&
      pio_C[ side^1 ][ PIO_PORT_CL ].type == PIO_READ  ){
    pio_mesC( "PIO C READ PORT Mismatch" );
  }
  if( pio_C[ side   ][ PIO_PORT_CH ].type == PIO_WRITE &&
      pio_C[ side   ][ PIO_PORT_CL ].type == PIO_WRITE ){
    pio_mesC( "PIO C Read from WRITE-PORT" );
  }
		/* ꡼ */

  if( pio_C[ side ][ PIO_PORT_CH ].type == PIO_READ ){
    data  = pio_C[ side^1 ][ PIO_PORT_CL ].data << 4;
  }else{
    data  = pio_C[ side   ][ PIO_PORT_CH ].data << 4;
  }

  if( pio_C[ side ][ PIO_PORT_CL ].type == PIO_READ ){
    data |= pio_C[ side^1 ][ PIO_PORT_CH ].data;
  }else{
    data |= pio_C[ side   ][ PIO_PORT_CL ].data;
  }

  pio_C[ side ][ PIO_PORT_CL ].chg_cnt ^= 1;
  if( pio_C[ side ][ PIO_PORT_CL ].chg_cnt == 0 ){	/* -- Ϣ³ɤߤ */

    switch( cpu_timing ){
    case 0:						/*     0:CPUؤ*/
      select_main_cpu ^= 1;
      z80[side]->discontinue = TRUE;
      /*z80sub_cpu.state = 0;*/
      break;
    case 1:						/*     1:CPUư */
      if( side==PIO_SIDE_M ){
	dual_cpu_count = CPU_1_COUNT;
	set_cpu_dormant( z80main_cpu );
      }
      break;
    case 2:						/*     2:ʤˤ⤷ʤ*/
    case 3:						/*     3:ʤˤ⤷ʤ*/
      break;
    default:						/*    -1:CPUؤ*/
      select_main_cpu ^= 1;
      z80[side]->discontinue = TRUE;
      break;
    }

  }

  return data;
}


/*----------------------------------------------------------------------*/
/* PIO C ˥饤							*/
/*	饤Ȥϡʬ¦ʬΥݡȤФƹԤʤ		*/
/*		ΥݡȤ꤬ WRITE ʤ饨顼ɽ		*/
/*		ʬΥݡȤ꤬  READ ʤ饨顼ɽ		*/
/*		饤ȤκݤˡCPUؤȽ			*/
/*----------------------------------------------------------------------*/
void	pio_write_C( int side, byte data )
{
  int port;

  if( data & 0x08 ) port = PIO_PORT_CH;
  else              port = PIO_PORT_CL;
  data &= 0x07;

		/* ݡ°԰ */

  if( pio_C[ side^1 ][ port^1 ].type == PIO_WRITE ){	/* Υݡ WRITE*/
    pio_mesC( "PIO C Write PORT Mismatch" );
  }
  if( pio_C[ side   ][ port   ].type == PIO_READ ){	/* ʬΥݡ READ */
    pio_mesC( "PIO C Write to READ-PORT" );
  }
		/* 饤 */

  if( data & 0x01 ) pio_C[ side ][ port ].data |=  ( 1 << (data>>1) );
  else              pio_C[ side ][ port ].data &= ~( 1 << (data>>1) );

  switch( cpu_timing ){
  case 0:						/*     0:Τޤ޽*/
  case 2:						/*     2:Τޤ޽*/
  case 3:						/*     3:Τޤ޽*/
    break;
  case 1:						/*     1:CPUư */
    if( side==PIO_SIDE_M ){
      dual_cpu_count = CPU_1_COUNT;
      set_cpu_dormant( z80main_cpu );
    }
    break;
  default:						/*    -1:CPUؤ */
    select_main_cpu ^= 1;
    /*z80sub_cpu.state = 0;*/
    if( side==PIO_SIDE_M ){
      dual_cpu_count = 1;
      set_cpu_dormant( z80main_cpu );
    }else{
      set_cpu_dormant( z80sub_cpu );
    }
    break;
  }
  return;
}


/*--------------------------------------------------------------*/
/* ľ Port C ˽񤭹					*/
/*--------------------------------------------------------------*/
void	pio_write_C_direct( int side, byte data )
{
		/* ݡ°԰ */
  if( pio_C[ side^1 ][ PIO_PORT_CH ].type == PIO_WRITE &&
      pio_C[ side^1 ][ PIO_PORT_CL ].type == PIO_WRITE ){
    pio_mesC( "PIO C WRITE PORT Mismatch" );
  }
  if( pio_C[ side   ][ PIO_PORT_CH ].type == PIO_READ  &&
      pio_C[ side   ][ PIO_PORT_CL ].type == PIO_READ  ){
    pio_mesC( "PIO C Write to READ-PORT" );
  }
		/* 饤 */

  pio_C[ side ][ PIO_PORT_CH ].data = data >> 4;
  pio_C[ side ][ PIO_PORT_CL ].data = data & 0x0f;

  switch( cpu_timing ){
  case 0:						/*     0:Τޤ޽*/
  case 2:						/*     2:Τޤ޽*/
  case 3:						/*     3:Τޤ޽*/
    break;
  case 1:						/*     1:CPUư */
    if( side==PIO_SIDE_M ){
      dual_cpu_count = CPU_1_COUNT;
      set_cpu_dormant( z80main_cpu );
    }
    break;
  default:						/*    -1:CPUؤ */
    select_main_cpu ^= 1;
    /*z80sub_cpu.state = 0;*/
    if( side==PIO_SIDE_M ){
      dual_cpu_count = 1;
      set_cpu_dormant( z80main_cpu );
    }else{
      set_cpu_dormant( z80sub_cpu );
    }
    break;
  }
  return;
}







/*----------------------------------------------------------------------*/
/* PIO 								*/
/*	PA / PB / PCH / PCL ꡣ				*/
/*	⡼ɤ (⡼ɤ 0 ˸ꡣܺ)			*/
/*----------------------------------------------------------------------*/
void	pio_set_mode( int side, byte data )
{
  if( data & 0x60 ){
    if( verbose_pio )
      printf("PIO mode A & CH not 0 : side = %s : mode = %d\n",
	     (side!=PIO_SIDE_M)?"M":"S", (data>>5)&0x3 );
  }
	/* PIO A */

  if( data & 0x10 ){
    pio_AB[ side ][ PIO_PORT_A ].type  = PIO_READ;
  }else{
    pio_AB[ side ][ PIO_PORT_A ].type   = PIO_WRITE;
  }
  pio_AB[ side ][ PIO_PORT_A ].data    = 0;
  pio_AB[ side ][ PIO_PORT_A ].exist   = PIO_EMPTY;
  pio_AB[ side ][ PIO_PORT_A ].chg_cnt = PIO_CHG_CNT;

	/* PIO C-H */

  if( data & 0x08 ){
    pio_C[ side ][ PIO_PORT_CH ].type  = PIO_READ;
  }else{
    pio_C[ side ][ PIO_PORT_CH ].type  = PIO_WRITE;
  }
  pio_C[ side ][ PIO_PORT_CH ].data    = 0;
  pio_C[ side ][ PIO_PORT_CH ].chg_cnt = 1;

  if( data & 0x04 ){
    if( verbose_pio )
      printf("PIO mode B & CL not 0 : side = %s : mode = %d\n",
	     (side!=PIO_SIDE_M)?"M":"S", (data>>2)&0x1 );
  }
	/* PIO B */

  if( data & 0x02 ){
    pio_AB[ side ][ PIO_PORT_B ].type  = PIO_READ;
  }else{
    pio_AB[ side ][ PIO_PORT_B ].type  = PIO_WRITE;
  }
  pio_AB[ side ][ PIO_PORT_B ].data    = 0;
  pio_AB[ side ][ PIO_PORT_B ].exist   = PIO_EMPTY;
  pio_AB[ side ][ PIO_PORT_B ].chg_cnt = PIO_CHG_CNT;

	/* PIO C-L */

  if( data & 0x01 ){
    pio_C[ side ][ PIO_PORT_CL ].type  = PIO_READ;
  }else{
    pio_C[ side ][ PIO_PORT_CL ].type  = PIO_WRITE;
  }
  pio_C[ side ][ PIO_PORT_CL ].data    = 0;
  pio_C[ side ][ PIO_PORT_CL ].chg_cnt = 1;

}






/****************************************************************/	
/* ڥɡ쥸塼					*/
/****************************************************************/	
static	T_SUSPEND_W	suspend_pio_work[]=
{
  { TYPE_INT,	&pio_AB[0][0].type,	},
  { TYPE_INT,	&pio_AB[0][0].exist,	},
  { TYPE_INT,	&pio_AB[0][0].chg_cnt,	},
  { TYPE_BYTE,	&pio_AB[0][0].data,	},

  { TYPE_INT,	&pio_AB[0][1].type,	},
  { TYPE_INT,	&pio_AB[0][1].exist,	},
  { TYPE_INT,	&pio_AB[0][1].chg_cnt,	},
  { TYPE_BYTE,	&pio_AB[0][1].data,	},

  { TYPE_INT,	&pio_AB[1][0].type,	},
  { TYPE_INT,	&pio_AB[1][0].exist,	},
  { TYPE_INT,	&pio_AB[1][0].chg_cnt,	},
  { TYPE_BYTE,	&pio_AB[1][0].data,	},

  { TYPE_INT,	&pio_AB[1][1].type,	},
  { TYPE_INT,	&pio_AB[1][1].exist,	},
  { TYPE_INT,	&pio_AB[1][1].chg_cnt,	},
  { TYPE_BYTE,	&pio_AB[1][1].data,	},

  { TYPE_INT,	&pio_C[0][0].type,	},
  { TYPE_INT,	&pio_C[0][0].exist,	},
  { TYPE_INT,	&pio_C[0][0].chg_cnt,	},
  { TYPE_BYTE,	&pio_C[0][0].data,	},

  { TYPE_INT,	&pio_C[0][1].type,	},
  { TYPE_INT,	&pio_C[0][1].exist,	},
  { TYPE_INT,	&pio_C[0][1].chg_cnt,	},
  { TYPE_BYTE,	&pio_C[0][1].data,	},

  { TYPE_INT,	&pio_C[1][0].type,	},
  { TYPE_INT,	&pio_C[1][0].exist,	},
  { TYPE_INT,	&pio_C[1][0].chg_cnt,	},
  { TYPE_BYTE,	&pio_C[1][0].data,	},

  { TYPE_INT,	&pio_C[1][1].type,	},
  { TYPE_INT,	&pio_C[1][1].exist,	},
  { TYPE_INT,	&pio_C[1][1].chg_cnt,	},
  { TYPE_BYTE,	&pio_C[1][1].data,	},
};


int	suspend_pio( FILE *fp, long offset )
{
  int	ret = suspend_work( fp, offset, 
			    suspend_pio_work, 
			    countof(suspend_pio_work) );

  if( ret<0 ) return FALSE;

  if( verbose_suspend )
    printf( "suspend <%s>: %d byte\n", __FILE__, ret );
  if( (int)sizeof( ((suspend_0*)0)->pio ) < ret ){
    fprintf( stderr, "SUSPEND ERROR : Size Overflow in <%s>\n",__FILE__);
    main_exit(4);
  }

  return TRUE;
}


int	resume_pio(  FILE *fp, long offset )
{
  int	ret = resume_work( fp, offset, 
			   suspend_pio_work, 
			   countof(suspend_pio_work) );

  if( ret<0 ) return FALSE;
  return TRUE;
}


void	pio_init_at_resume( void )
{
}
