/************************************************************************/
/* QUASI88 --- PC-8801 emulator						*/
/*	 Copyright (C) Showzoh Fukunaga 1998,1999,2000			*/
/*									*/
/*									*/
/*	  ΥեȤϡUNIX + X Window System δĶư롢	*/
/*	PC-8801 Υߥ졼Ǥ					*/
/*									*/
/*	  ΥեȤκˤꡢMarat Fayzullin fMSX	*/
/*	Nicola Salmoria ( MAME/XMAME project)  mame/xmame	*/
/*	ߤ PC6001V Υ򻲹ͤˤƤ餤ޤ	*/
/*									*/
/*	ա							*/
/*	  ɥɥ饤Фϡmame/xmame ΥήѤƤޤ	*/
/*	ʬΥϡmame/xmame ढ뤤ϥ	*/
/*	ܤƤԤˤޤ					*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "quasi88.h"
#include "initval.h"

#include "pc88main.h"
#include "pc88sub.h"
#include "graph.h"
#include "memory.h"
#include "file-op.h"

#include "emu.h"
#include "drive.h"
#include "getconf.h"
#include "monitor.h"
#include "snddrv.h"
#include "wait.h"
#include "indicator.h"
#include "suspend.h"
#include "snapshot.h"


int	verbose_level	= DEFAULT_VERBOSE;	/* Ĺ٥		*/
int	verbose_proc    = FALSE;		/* οʹԾɽ	*/
int	verbose_z80	= FALSE;		/* Z80顼ɽ	*/
int	verbose_io	= FALSE;		/* ̤I/Oɽ*/
int	verbose_pio	= FALSE;		/* PIO Ѥɽ */
int	verbose_fdc	= FALSE;		/* FD᡼۾	*/
int	verbose_wait	= FALSE;		/* Ȼΰ۾ */
int	verbose_suspend = FALSE;		/* ڥɻΰ۾ */
int	verbose_snd	= FALSE;		/* ɤΥå	*/


/*----------------------------------------------------------------------*/
/* 뤿νդ						*/
/*----------------------------------------------------------------------*/

#if defined(PIO_FILE) || defined(FDC_FILE) || defined(MAIN_FILE) || defined(SUB_FILE)
FILE	*LOG = NULL;
#endif

static	void	debug_log_init( void )
{
#if defined(PIO_FILE) || defined(FDC_FILE) || defined(MAIN_FILE) || defined(SUB_FILE)
  LOG = fopen("log","w");
#endif
  if( verbose_proc ){
#if	defined( PIO_DISP ) || defined( PIO_FILE )
    printf("+ Support PIO logging. set variable \"pio_debug\" to 1.\n");
#endif
#if	defined( FDC_DISP ) || defined( FDC_FILE )
    printf("+ Support FDC logging. set variable \"fdc_debug\" to 1.\n");
#endif
#if	defined( MAIN_DISP ) || defined( MAIN_FILE )
    printf("+ Support Main Z80 logging. set variable \"main_debug\" to 1.\n");
#endif
#if	defined( SUB_DISP ) || defined( SUB_FILE )
    printf("+ Support Sub Z80 logging. set variable \"sub_debug\" to 1.\n");
#endif
  }
}

static	void	debug_log_finish( void )
{
#if defined(PIO_FILE) || defined(FDC_FILE) || defined(MAIN_FILE) || defined(SUB_FILE)
  if( LOG ) fclose(LOG);
#endif
}



/************************************************************************/
/* QUASI88 ᥤؿ							*/
/*	    ߥ졼ȴؿƤӽФ  λ		*/
/************************************************************************/
static	int	proc;
int	main( int argc, char *argv[] )
{
  int status;

  proc = 0;


  osd_get_environment( &status );			/* Ķѿ	*/
  if( status & ENV_NO_HOME )
    fprintf( stderr, "<warning> ${HOME} is not defined.\n" );
  if( status & ENV_INVALID_HOME )
    fprintf( stderr, "<warning> ${HOME} is invalid.\n" );
  if( status & ENV_NO_MEM_ROM_DIR )
    fprintf( stderr, "<warning> Malloc Failed (ROM_DIR)" );
  if( status & ENV_NO_MEM_DISK_DIR )
    fprintf( stderr, "<warning> Malloc Failed (DISK_DIR)" );

  xmame_system_init();

  if( ! config_init( argc, argv ) ) main_exit(1);	/* 	*/

  verbose_proc	= verbose_level & 0x01;
  verbose_z80	= verbose_level & 0x02;
  verbose_io	= verbose_level & 0x04;
  verbose_pio	= verbose_level & 0x08;
  verbose_fdc	= verbose_level & 0x10;
  verbose_wait	= verbose_level & 0x20;
  verbose_suspend=verbose_level & 0x40;
  verbose_snd	= verbose_level & 0x80;


  if( verbose_proc ){
    if( exist_rcfile() )
      printf( "${HOME}/" QUASI88RC_FILE " read and initialized\n");
    else
      printf( "${HOME}/" QUASI88RC_FILE " open failed!\n");
  }

  resume_init();			/* ڥɡ쥸塼Ϣ */
  screen_snapshot_init();		/* ̥ʥåץåȴϢ */


  if( graphic_system_init() ){		/* եåƥ	*/
    proc = 1;

    if( xmame_sound_start() ){		/* ɥɥ饤н	*/
      proc = 2;

      if( memory_allocate() ){		/* ߥ졼ѥγ	*/
	proc = 3;

	set_signal();			/* INTʥν	*/

	drive_init();			/* եåԡɥ饤֤ν	*/

	if( resume_flag == 0 ){
	  disk_set_args_file();		/*   Υե򥻥å	*/

	  bootup_work_init();		/* ˱ơ	*/
	  pc88main_init(TRUE);
	  pc88sub_init();

	  power_on_ram_init();		/* RAMν(ŸľΤ)*/

	}else{				/* 쥸塼ह		*/

	  if( file_resume == NULL ||		/* ե̤̾	   */
	      ! resume( file_resume ) ){	/* ⤷ 쥸塼༺ */

	    fprintf( stderr, "resume: Failed ! (filename = %s)\n",
		     file_resume ? file_resume
				 : "${HOME}/" QUASI88STATE_FILE );
	    main_exit(1);
	  }

	  fdc_init_at_resume();

	  pc88main_init_at_resume();
	  pc88sub_init_at_resume();

	}

	debug_log_init();

	if( wait_vsync_init() ){	/* ѥޡ	*/
	  proc = 4;
	  if( verbose_proc ) printf( "Running QUASI88...\n" );

	  if( resume_flag == 0 )
	    indicate_bootup_logo();	/* ȥɽ */

	  emu();			/* ߥ졼 ᥤ */

	  if( verbose_proc ) printf( "Shutting down.....\n" );
	  wait_vsync_term();
	}

	debug_log_finish();

	pc88main_term();
	pc88sub_term();

	disk_eject( 0 );
	disk_eject( 1 );

	memory_free();
      }
      xmame_sound_stop( );
    }
    graphic_system_term( );
  }



	/* ܺɽ򤷤ʤäΡ顼ɽ */

  if( !verbose_proc ){
    switch( proc ){
    case 0:	fprintf(stderr,"graphic system initialize failed!\n");	break;
    case 1:	fprintf(stderr,"sound system initialize failed!\n");	break;
    case 2:	fprintf(stderr,"memory allocate failed!\n");		break;
    case 3:	fprintf(stderr,"timer initialize failed!\n");		break;
    }
  }

  xmame_system_term();

  return (0);
}




/************************************************************************/
/* QUASI88 潪λؿ						*/
/*	exit() ˸Ƥܤ					*/
/*	 val ȡեåθʤΤǡա	*/
/************************************************************************/
void	main_exit( int val )
{
  switch( proc ){
  case 4:
    wait_vsync_term();			/* FALLTHROUGH */
  case 3:
    debug_log_finish();
    pc88main_term();
    pc88sub_term();
    disk_eject( 0 );
    disk_eject( 1 );
    memory_free();			/* FALLTHROUGH */
  case 2:
    xmame_sound_stop( );		/* FALLTHROUGH */
  case 1:
    if( val>= 0 ) graphic_system_term( );
  }

  xmame_system_term();

  exit( val );
}





/************************************************************************/
/* QUASI88 ưΥꥻåȽؿ					*/
/************************************************************************/
void	main_reset( void )
{
  int	empty[2];

  pc88main_term();
  pc88sub_term();
  pc88main_init(FALSE);
  pc88sub_init();

  pc88main_break_point();
  pc88sub_break_point();

  empty[0] = drive_check_empty(0);
  empty[1] = drive_check_empty(1);
  drive_reset();
  if( empty[0] ) drive_set_empty(0);
  if( empty[1] ) drive_set_empty(1);
  if( use_sound ) xmame_sound_reset();
}
