/************************************************************************/
/*									*/
/* ɤν (顢XMAMEδؿƤӽФ)			*/
/*									*/
/*	٤ơXMAME νԤʤؿ				*/
/*	QUASI88 ϡδؿ̤ơXMAMEΥɽԤʤ	*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>


#define __XMAME_QUASI88_C_
#include "xmame-quasi88.h"

#include "sysdep_mixer.h"	/* sysdep_mixer_init()	*/
#include "fm.h"			/* YM2203TimerOver()	*/

static struct rc_struct *rc;

extern	struct rc_option sound_opts[];

T_XMAME_FUNC	*xmame_func      = &xmame_func_nosound;


int		use_sound = TRUE;	/* 0:not use / 1 use sound	*/


/****************************************************************/
/* XMAME ΥɤѤ뤿νλؿ		*/
/****************************************************************/
int	xmame_system_init( void )
{
   /* create the rc object */
   if (!(rc = rc_create()))
      return OSD_NOT_OK;

   if(sysdep_dsp_init(rc, NULL))
      return OSD_NOT_OK;

   if(sysdep_mixer_init(rc, NULL))
      return OSD_NOT_OK;

   if(rc_register(rc, sound_opts))
      return OSD_NOT_OK;

   return OSD_OK;
}

void	xmame_system_term( void )
{
   if(rc)
   {
      sysdep_mixer_exit();
      sysdep_dsp_exit();
      rc_destroy(rc);
   }
}


/****************************************************************/
/* XMAME ΥץϤ뤿δؿ			*/
/* -1 ­ʤϰϳ					*/
/* 0  ץʤ					*/
/* 1  1Ľ (ͥ٤ˤޤ)			*/
/* 2  2Ľ (ͥ٤ˤޤ)			*/
/****************************************************************/
int	xmame_check_option( char *arg1, char *arg2, int priority )
{
  return rc_quasi88( rc, arg1, arg2, priority );
}




/****************************************************************/
/* XMAME Υץɽ뤿δؿ			*/
/****************************************************************/
void	xmame_show_option( void )
{
  fprintf( stdout, 
	   "\n"
	   "==========================================\n"
	   "== SOUND OPTIONS ( dependent on xmame ) ==\n"
	   "==                    [ xmame  0.71.1 ] ==\n"
	   "==========================================\n"
	   );

  rc_print_help(rc, stdout);
}




/****************************************************************/
/* XMAME Υɤγ					*/
/* XMAME Υɤι					*/
/* XMAME Υɤνλ					*/
/* XMAME Υɤ					*/
/* XMAME ΥɤκƳ					*/
/* XMAME ΥɤΥꥻå					*/
/****************************************************************/
int	xmame_sound_start( void )
{
  if(verbose_proc) printf("Starting sound server: ");

  if( sound_start()==0 ){

    xmame_func_set(use_sound);

    if(verbose_proc) printf("OK\n");
    sound_reset();

  }else{

    if(verbose_proc) printf("FAILED...Can't use sound\n");

  }
  return 1;
}

void	xmame_sound_update( void )
{
  sound_update();
}

void	xmame_sound_stop( void )
{
  sound_stop();
}

void	xmame_sound_suspend( void )
{
  if( close_device )
    osd_sound_enable(0);
}
void	xmame_sound_resume( void )
{
  if( close_device )
    osd_sound_enable(1);
}
void	xmame_sound_reset( void )
{
  sound_reset();
}

int	xmame_sound_is_enable( void )
{
  if( sound_stream ) return TRUE;
  else               return FALSE;
}

/*
  ɽϤή

  src/mame.c
	int updatescreen(void)		VSYNC Υߥ󥰤ˤơƤӽФ롣
	{
	    sound_update();				PCMǡ
	    :
	    update_video_and_audio();
	    :
	}

  src/mame.c
	void update_video_and_audio(void)
	{
	    :
	    artwork_update_video_and_audio(...);
	    :
	}

  src/artwork.c
	void artwork_update_video_and_audio(...)
	{
	    :
	    osd_update_video_and_audio(display);
	    :
	}

  src/unix/video.c
	void osd_update_video_and_audio(...)
	{
	  ...						Ĵ usleep
	      :
	  if (sound_stream && sound_enabled)		PCMǡ
	     sound_stream_update(sound_stream);
	      :
	  ...						
	}
*/

void	xmame_update_video_and_audio( void )
{
   if (sound_stream && sound_enabled)
      sound_stream_update(sound_stream);
}


/****************************************************************/
/* ɥݡ˸Ƥ					*/
/****************************************************************/
byte	xmame_sound_in_data( void )
{
  if( xmame_func->sound_in_data ) return (xmame_func->sound_in_data)(0);
  else                            return 0xff;
}
byte	xmame_sound_in_status( void )
{
  if( xmame_func->sound_in_data ) return (xmame_func->sound_in_status)(0);
  else                            return 0;
}
void	xmame_sound_out_reg( byte data )
{
  if( xmame_func->sound_in_data ) (xmame_func->sound_out_reg)(0,data);
}
void	xmame_sound_out_data( byte data )
{
  if( xmame_func->sound_in_data ) (xmame_func->sound_out_data)(0,data);
}


byte	xmame_sound2_in_data( void )
{
  if( !use_sound ) return 0xff;
  else{
    if( sound_board==SOUND_I ) return 0xff;
    else                       return 0;
  }
}
byte	xmame_sound2_in_status( void )
{
  if( xmame_func->sound_in_data ) return (xmame_func->sound2_in_status)(0);
  else                            return 0xff;
}
void	xmame_sound2_out_reg( byte data )
{
  if( xmame_func->sound_in_data ) (xmame_func->sound2_out_reg)(0,data);
}
void	xmame_sound2_out_data( byte data )
{
  if( xmame_func->sound_in_data ) (xmame_func->sound2_out_data)(0,data);
}


void	xmame_beep_out_data( byte data )
{
  if( xmame_func->beep_out_data ) (xmame_func->beep_out_data)(0,data);
}




/****************************************************************/
/* ɤΥޡСե˸Ƥ			*/
/*	timer = 0 TimerAOver / 1 TimerBOver			*/
/****************************************************************/
void	xmame_sound_timer_over( int timer )
{
  if( xmame_func->sound_timer_over ) (xmame_func->sound_timer_over)(0, timer);
}




/****************************************************************/
/* ܥ塼						*/
/*	ߤβ̤					*/
/****************************************************************/
int	xmame_get_sound_volume( void )
{
  return osd_get_mastervolume();
}

/****************************************************************/
/* ܥ塼ѹ						*/
/*	ˡ̤Ϳ롣̤ϡ-320 ޤ		*/
/****************************************************************/
void	xmame_set_sound_volume( int vol )
{
    if( vol > VOL_MAX ) vol = VOL_MAX;
    if( vol < VOL_MIN ) vol = VOL_MIN;
    osd_set_mastervolume( vol );
}



/****************************************************************/
/* ̥ͥ٥					*/
/*	ˡͥͿ				*/
/*	ͥϡ0==PSG 1==FM2==BEEP			*/
/*	 xmame ǤΥͥ				*/
/*	    ɥܡI	CH02  PSG			*/
/*				CH3	FM      		*/
/*				CH4	BEEP      		*/
/*	    ɥܡII	CH02  PSG			*/
/*				CH3	FM(L)			*/
/*				CH4	FM(R)			*/
/*				CH5	BEEP			*/
/****************************************************************/
int	xmame_get_mixer_volume( int ch )
{
  if( use_fmgen==0 ){
    if( sound_board==SOUND_I ){
      switch( ch ){
      case XMAME_MIXER_PSG:	ch = 0;		break;
      case XMAME_MIXER_FM:	ch = 3;		break;
      case XMAME_MIXER_BEEP:	ch = 4;		break;
      case XMAME_MIXER_RHYTHM:	return 0;
      case XMAME_MIXER_ADPCM:	return 0;
      default:			return 0;
      }
    }else{
      switch( ch ){
      case XMAME_MIXER_PSG:	ch = 0;		break;
      case XMAME_MIXER_FM:	ch = 3;		break;
      case XMAME_MIXER_BEEP:	ch = 5;		break;
      case XMAME_MIXER_RHYTHM:	return rhythmvol;
      case XMAME_MIXER_ADPCM:	return adpcmvol;
      default:			return 0;
      }
    }
  }else{
    switch( ch ){
    case XMAME_MIXER_FMPSG:	ch = 0;		break;
    case XMAME_MIXER_BEEP:	ch = 2;		break;
    default:			return 0;
    }
  }
  return mixer_get_mixing_level( ch );
}

/****************************************************************/
/* ̥ͥ٥ѹ					*/
/*	ˡͥȥ٥Ϳ			*/
/*	٥ϡ    0100 ޤ				*/
/*	ͥϡ0==PSG 1==FM2==BEEP			*/
/*				ʳϰɽ	*/
/*	 xmame ǤΥͥ				*/
/*	    ɥܡI	CH02  PSG			*/
/*				CH3	FM      		*/
/*				CH4	BEEP      		*/
/*	    ɥܡII	CH02  PSG			*/
/*				CH3	FM(L)			*/
/*				CH4	FM(R)			*/
/*				CH5	BEEP			*/
/*	    FMGENξ		CH0	PSG/FM(L)		*/
/*				CH2	PSG/FM(R)		*/
/*				CH2	BEEP      		*/
/****************************************************************/
void	xmame_set_mixer_volume( int ch, int level )
{
  if( use_fmgen ){
  switch( ch ){
  case XMAME_MIXER_FMPSG:
    if( level < FMPSGVOL_MIN ) level = FMPSGVOL_MIN;
    if( level > FMPSGVOL_MAX ) level = FMPSGVOL_MAX;
    mixer_set_mixing_level( 0, level );
    mixer_set_mixing_level( 1, level );
    break;
  case XMAME_MIXER_BEEP:
    if( level < BEEPVOL_MIN ) level = BEEPVOL_MIN;
    if( level > BEEPVOL_MAX ) level = BEEPVOL_MAX;
    mixer_set_mixing_level( 2, level );
    break;
  default:
    for( ch=0; ch<MIXER_MAX_CHANNELS ; ch++ ){
      const char *name = mixer_get_name(ch);
      if(name) printf( "%d[ch] %s\t:%d\n", ch,name,mixer_get_mixing_level(ch));
    }
    break;
  }
  return;
  }

  switch( ch ){
  case XMAME_MIXER_PSG:
    if( level < PSGVOL_MIN ) level = PSGVOL_MIN;
    if( level > PSGVOL_MAX ) level = PSGVOL_MAX;
    mixer_set_mixing_level( 0, level );
    mixer_set_mixing_level( 1, level );
    mixer_set_mixing_level( 2, level );
    break;
    
  case XMAME_MIXER_FM:
    if( level < FMVOL_MIN ) level = FMVOL_MIN;
    if( level > FMVOL_MAX ) level = FMVOL_MAX;
    if( sound_board==SOUND_I ){
      mixer_set_mixing_level( 3, level );
    }else{
      mixer_set_mixing_level( 3, level );
      mixer_set_mixing_level( 4, level );
    }
    break;
    
  case XMAME_MIXER_BEEP:
    if( level < BEEPVOL_MIN ) level = BEEPVOL_MIN;
    if( level > BEEPVOL_MAX ) level = BEEPVOL_MAX;
    if( sound_board==SOUND_I ){
      mixer_set_mixing_level( 4, level );
    }else{
      mixer_set_mixing_level( 5, level );
    }
    break;

  case XMAME_MIXER_RHYTHM:
    if( level < RHYTHMVOL_MIN ) level = RHYTHMVOL_MIN;
    if( level > RHYTHMVOL_MAX ) level = RHYTHMVOL_MAX;
    if( sound_board==SOUND_II ){
      rhythmvol = level;
    }
    break;

  case XMAME_MIXER_ADPCM:
    if( level < ADPCMVOL_MIN ) level = ADPCMVOL_MIN;
    if( level > ADPCMVOL_MAX ) level = ADPCMVOL_MAX;
    if( sound_board==SOUND_II ){
      adpcmvol = level;
    }
    break;

  default:
    for( ch=0; ch<MIXER_MAX_CHANNELS ; ch++ ){
      const char *name = mixer_get_name(ch);
      if(name) printf( "%d[ch] %s\t:%d\n", ch,name,mixer_get_mixing_level(ch));
    }
    break;
  }
}

