/************************************************************************/
/*									*/
/* ĴѴؿ (OS¸)						*/
/*									*/
/* ڴؿ								*/
/*									*/
/* int  wait_vsync_init( void )		Ƚ		*/
/* void wait_vsync_term( void )		Ƚ		*/
/* void	wait_vsync_reset( void )	Ⱥƽ (ѹ)	*/
/* void wait_vsync( void )					*/
/*									*/
/*	gettimeofday() ؿǸ߻åȤɬפʤ	*/
/*	Ĵ롣						*/
/*	-nosleep ϡgettimeofday()ǻַвݡ󥰤	*/
/*	-sleep   ϡselect() sleep 			*/
/*									*/
/*	  gettimeofday() ؿANSIɸǤϤʤΤǡδؿȤʤ	*/
/*	ϡANSI ɸ clock() ؿѤ롣			*/
/*	  select()ؿȤʤϡġġ -sleep Բ		*/
/*			(usleep Ȥ poll ȤѤƤ褤ġ)	*/
/*									*/
/************************************************************************/
#include <stdio.h>

#include "quasi88.h"
#include "initval.h"
#include "wait.h"
#include "suspend.h"

#include "screen.h"	/* auto_skip... */

#ifdef	HAVE_SELECT
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#endif




double	wait_freq_hz = DEFAULT_WAIT_FREQ_HZ;	/* ĴѼȿ [Hz] */
int	wait_by_sleep = FALSE;			/* ȴ sleep  */

long	wait_sleep_min_us = 100;		/* Ĥ idle֤ s
						   ʲʤ sleep ʤ
						   ( 1̤ꤹ뤳! )*/


/*
 * ưե졼ॹå		( by floi, thanks ! )
 */

static	int	skip_counter = 0;		/* Ϣ³ǥåפ */
static	int	skip_count_max = 15;		/* 祹åײ
						   ʾˤʤä鸽߻ꥻå */



/*
 * Ƚؿ
 */

typedef struct{			/* struct timeval Ʊ */
  long tv_sec;
  long tv_usec;
} T_WAIT_TIMEVAL;

#define	WAIT_CMP( a, b, cmp )	((a.tv_sec == b.tv_sec) ?	\
				 (a.tv_usec cmp b.tv_usec) :	\
				 (a.tv_sec  cmp b.tv_sec)   )

#define	WAIT_ADD( a, b )	a.tv_sec  += b.tv_sec ;		\
				a.tv_usec += b.tv_usec;		\
				if( a.tv_usec >= 1000000 ){	\
				  a.tv_sec ++;			\
				  a.tv_usec -= 1000000;		\
				}

#define	WAIT_SUB( x, a, b )	x.tv_sec  = a.tv_sec  - b.tv_sec ;	\
				x.tv_usec = a.tv_usec - b.tv_usec;	\
				if( x.tv_usec < 0 ){			\
				  x.tv_sec --;				\
				  x.tv_usec += 1000000;			\
				}

static	int	wait_error = FALSE;		/* ǰ۾ȯ */


/*
 * ߻ؿ int get_now_timeval( T_WAIT_TIMEVAL *now )
 *	ˤϡ0 ֤
 */

#ifdef  HAVE_GETTIMEOFDAY	/* -------- gettimeofday() Ѥ ------ */
#include <sys/time.h>

INLINE	int	get_wait_timeval( T_WAIT_TIMEVAL *now )
{
  struct timeval tv;
  if( gettimeofday( &tv, 0 ) ){
    if( verbose_wait ) printf( "Error Wait (gettimeofday())\n" );
    return -1;
  }else{
    now->tv_sec  = tv.tv_sec;
    now->tv_usec = tv.tv_usec;
    return 0;
  }
}


#else				/* -------- clock() Ѥ ------------- */
#include <time.h>

/* #define CLOCK_SLICE	CLK_TCK */		/* 줸ܡ */
#define	CLOCK_SLICE	CLOCKS_PER_SEC		/* ä */

INLINE	int	get_wait_timeval( T_WAIT_TIMEVAL *now )
{
  clock_t t = clock();
  if( t == (clock_t)-1 ){
    if( verbose_wait ) printf( "Error Wait\n" );
    return -1;
  }else{
    now->tv_sec  =  t / CLOCK_SLICE;
    now->tv_usec = (double)(t % CLOCK_SLICE) * 1000000.0 / CLOCK_SLICE;
    return 0;
  }
}

#endif				/* ----------------------------------------- */





int	wait_vsync_init( void )
{
  wait_vsync_reset();
  return TRUE;
}


void	wait_vsync_term( void )
{
}



static	T_WAIT_TIMEVAL	next_tick;		/* 󥦥Ĵ */
static	T_WAIT_TIMEVAL	add_frame;		/* Ȥμ	*/
static	T_WAIT_TIMEVAL	sleep_min;		/* ȤκǾ	*/

void	wait_vsync_reset( void )
{
  if( get_wait_timeval( &next_tick ) ){
    wait_error = TRUE;

  }else{
    wait_error = FALSE;

    add_frame.tv_sec  = 0;				/* Ȥμ */
    add_frame.tv_usec = 1000000 / wait_freq_hz;

    sleep_min.tv_sec  = 0;				/* sleep Ǿ */
    sleep_min.tv_usec = wait_sleep_min_us;

    WAIT_ADD( next_tick, add_frame );			/* λ */
  }
}


void	wait_vsync( void )
{
  int	on_time = FALSE;
  T_WAIT_TIMEVAL now, delay;
  int sleep_flag = wait_by_sleep;	/* idle  sleep Ʋᤴե饰 */

  if( wait_error ) return;

  while( 1 ){

    if( get_wait_timeval( &now ) ){		/* ߻ */
      wait_error = TRUE;
      return;
    }

					/* ȼ˽̤ ! ====== */

    if( WAIT_CMP( next_tick, now, <= ) ){
#if 0
      next_tick = now;
      on_time = TRUE;
#else
      WAIT_SUB( delay, now, next_tick );	/* ɤΰ̤٤줫򻻽С   */
      if( WAIT_CMP( add_frame, delay, < ) ){	/* 1ʾ٤ƤС  */
	next_tick = now;			/*    ͺƽ      */
	on_time = TRUE;
      }else{					/* ʤ٤Ƥʤʤ顢 */
	;					/*    Τޤ³          */
      }
#endif
      WAIT_ADD( next_tick, add_frame );
      break;
    }


					/* ȼ˽λ ! ====== */
    on_time = TRUE;

#ifdef	HAVE_SELECT
    if( sleep_flag ){

      WAIT_SUB( delay, next_tick, now );	/* Ĥ֤򻻽С        */

      if( WAIT_CMP( delay, sleep_min, < ) ){	/* Ĥ꾯ʤϡ      */
	sleep_flag = FALSE;			/* 	polling Ʋᤴ */

      }else{					/* 빽ĤäƤϡ    */
	struct timeval tv;			/*	sleep Ʋᤴ   */
#if 0
	WAIT_SUB( delay, delay, sleep_min );
	tv.tv_sec  = delay.tv_sec;
	tv.tv_usec = delay.tv_usec;
	select( 0, NULL, NULL, NULL, &tv );
	sleep_flag = FALSE;
#else
	tv.tv_sec  = delay.tv_sec;
	tv.tv_usec = delay.tv_usec;
	select( 0, NULL, NULL, NULL, &tv );
	WAIT_ADD( next_tick, add_frame );
	break;
#endif
      }

    }
#endif

    /* ַвƻ뤷³ (polling) */
  }



  /*
   * ưե졼ॹå׽		( by floi, thanks ! )
   */
  if( use_auto_skip ){
    if( on_time ){			/* ˽Ǥ */
/*if(skip_counter)printf("%x\n",skip_counter);*/
      skip_counter = 0;
      do_skip_draw = FALSE;
      if( already_skip_draw ){		/* 򥹥åפƤ */
	already_skip_draw = FALSE;
	reset_frame_counter();		/* ɬ褹 */
      }
    }else{				/* ˽ǤƤʤ */
      skip_counter++;
      if( skip_counter >= skip_count_max ){	/* åפ */
	skip_counter = 0;
	do_skip_draw = FALSE;
	already_skip_draw = FALSE;
	reset_frame_counter();			/* ɬ褹 */
	next_tick = now;				/* Ĵľ  */
      }else{
	do_skip_draw = TRUE;			/* 򥹥åפɬͭ */
      }
    }
  }

  return;
}






/****************************************************************/	
/* ڥɡ쥸塼					*/
/****************************************************************/	
static	T_SUSPEND_W	suspend_wait_work[] =
{
  { TYPE_DOUBLE,	&wait_freq_hz,	},
};


int	suspend_wait( FILE *fp, long offset )
{
  int	ret = suspend_work( fp, offset, 
			    suspend_wait_work, 
			    countof(suspend_wait_work) );

  if( ret<0 ) return FALSE;

  if( verbose_suspend )
    printf( "suspend <%s>: %d byte\n", __FILE__, ret );
  if( (int)sizeof( ((suspend_0*)0)->wait ) < ret ){
    fprintf( stderr, "SUSPEND ERROR : Size Overflow in <%s>\n",__FILE__);
    main_exit(4);
  }

  return TRUE;
}


int	resume_wait(  FILE *fp, long offset )
{
  int	ret = resume_work( fp, offset, 
			   suspend_wait_work, 
			   countof(suspend_wait_work) );

  if( ret<0 ) return FALSE;
  return TRUE;
}
